package Admin::Index;
use strict;
#################################################################################
# Ikonboard v3 by Jarvis Entertainment Group, Inc.
#
# No part of this script can be used outside Ikonboard without prior consent.
#
# More information available from <ib-license@jarvisgroup.net>
# (c)2001 Jarvis Entertainment Group, Inc.
# 
# http://www.ikonboard.com | http://www.jarvisgroup.net
#
# Please read the license for more information
#
# 
# Script Author: Matthew Mecham <matt@ikonboard.com>
#
#################################################################################

BEGIN {
    require 'Lib/FUNC.pm';
    require 'Lib/ADMIN.pm';
    require 'Admin/SKIN.pm';
    require 'Boardinfo.pm' or die "Cannot load Module: $!";
}

my $SKIN  = Admin::SKIN->new();
my $std   = FUNC::STD->new();
my $mem   = FUNC::Member->new();
my $ADMIN = FUNC::ADMIN->new();
my $INFO  = Boardinfo->new();

sub new {
    my $pkg = shift;
    my $obj = {};
    bless $obj, $pkg;
    return $obj;
}

sub process {
    my ($obj, $db) = @_;

    my $stats = $db->select( TABLE   => 'board_statistics',
                             KEY     => 'MAIN',
                           );

    my $qd_mem = $db->query( TABLE   => 'member_profiles',
                             WHERE   => qq[MEMBER_GROUP == "$INFO->{'AUTHORISE_GROUP'}"],
                             COUNT   => 1
                           );

    my $qd_mem ||= 0;
    
    $stats->{'TOTAL_TOPICS'}  ||= 0;
    $stats->{'TOTAL_REPLIES'} ||= 0;


    my $html = qq~

    <table cellspacing='0' cellpadding='5' border='0' width='100%' border='0'>
    <tr>
    <td><font class='t'>
    Welcome to your Administrative Control Panel. Here you can contol evey aspect of the forum and change the
    way it looks and works.
    </font>
    </td>
    </tr>
    <tr>
    <td><font class='t'>
    <b>Quick Statistic Rundown</b>
    <br><br>You have $qd_mem members awaiting authorisation to post.
    <br>
    <br>Total members: $stats->{'TOTAL_MEMBERS'}
    <br>Total Topics : $stats->{'TOTAL_TOPICS'}
    <br>Total Posts  : $stats->{'TOTAL_TOPICS'} + $stats->{'TOTAL_REPLIES'}
    <br><br>
    More stuff later..
    </font>
    </td>
    </tr>
    </table>
    ~;

    $ADMIN->Output( WHERE => 'WELCOME', NAV_ONE => 'Welcome to your CP', PRINT => $html);

}  






1;
__END__









