package FUNC::STD;
use strict;
#+-----------------------------------------------------------------+
#| Ikonboard v3 by Jarvis Entertainment Group, Inc.
#|
#| No parts of this script can be used outside Ikonboard without prior consent.
#|
#| More information available from <ib-license@jarvisgroup.net>
#| (c)2001 Jarvis Entertainment Group, Inc.
#| 
#| http://www.ikonboard.com
#|
#| Please Read the license for more information
#+-----------------------------------------------------------------+
#
# Standard Ikonboard Routines.
#
#+-----------------------------------------------------------------+


BEGIN {
    require 'Boardinfo.pm' or die "Cannot load Module: $!";
}

use Time::localtime;
my $INFO = Boardinfo->new();


sub new {
    my $pkg = shift;
    my $obj = {};
    bless $obj, $pkg;
    $Universal::lang = $obj->LoadLanguage('UniversalWords');
    return $obj;
}



sub LoadSkin {
    my $obj = shift;
    my $Skin = $iB::MEMBER->{'MEMBER_SKIN'} eq '' ? 'Default' : $iB::MEMBER->{'MEMBER_SKIN'};
    require $Skin . '/Styles.pm';
    my $Return = Styles->new();
    $Return->{'DIR'} = $Skin;
    $Return->{'FULL_DIR'} = 'Skin/' . $Return->{'DIR'};
    $Return->{'IMAGES_URL'} = $INFO->{'IMAGES_URL'} .'/'.$Return->{'FULL_DIR'};
    return $Return;
 
}


sub LoadLanguage {
    my ($obj, $area) = @_;
    my $lang;
    $iB::MEMBER->{'LANGUAGE'} = 'en' unless $iB::MEMBER->{'LANGUAGE'};
    $iB::MEMBER->{'LANGUAGE'} =~ s!([\w\d])!$1!g;
    $area =~ s!([\w\d])!$1!g;
    my $code = 'require '. "\"$iB::MEMBER->{'LANGUAGE'}/" .$area. '.pm"; $lang ='. $area. '->new();';
    eval $code;
    $obj->cgi_error("Could not access the language file: $@") if $@;
    return $lang;
}

sub build_forumjump {
    my $obj = shift;
    my %IN  = ( DB     => "",
                CATS   => "",
                FORUMS => "",
                @_,
              );

    return unless $IN{'DB'} and $IN{'CATS'} and $IN{'FORUMS'};

    require 'Lib/ADMIN.pm';
    my $admin = FUNC::ADMIN->new();

    my $data = {};
    my $i = 0;    

    #Key Name: number
    #Key Data: [ 'CAT || F',  'ID', 'NAME', 'VIEW' ];

    for my $this_cat (@{ $IN{'CATS'} }) {
        $data->{ $i } = [ 'c', $this_cat->{'CAT_ID'}, $this_cat->{'CAT_NAME'}, $this_cat->{'VIEW'} ];
        $i++;
        #Get the forums for this category
        my @these_cat_forums = grep { $_->{'CATEGORY'} == $this_cat->{'CAT_ID'} } @{ $IN{'FORUMS'} };

        for my $f (@these_cat_forums) {
            $data->{ $i } = [ 'f', $f->{'FORUM_ID'}, $f->{'FORUM_NAME'}, $f->{'FORUM_VIEW_THREADS'} ];
            $i++;
        }
    }

    $admin->make_module( FILE     => 'ForumJump.pm',
                         PKG_NAME => 'ForumJump',
                         VALUES   => $data
                       );

    return 1;
}



sub cgi_error {
    my ($obj, $error) = @_;
    my $help;

    $error =~ s!$INFO->{'DB_DIR'}!/your/path/to/database_dir/!ig
        ||
    $error =~ s!$INFO->{'IKON_DIR'}!/your/path/to/ikon_dir/!ig
        ||
    $error =~ s!$INFO->{'HTML_DIR'}!/your/path/to/html_dir/!ig
        ||
    $error =~ s!$ENV{'DOCUMENT_ROOT'}!/your/path/to/!ig;

    my ($msg, $path) = split " at ",$error;

    unless ($msg) {
        $msg  = "No error was returned";
        $help = "Well, that's spooky - an error without an error. Time to panic!";
    }

    $help = "oooh, a database error, don't you feel special now?! ".
            "If you are setting up the board, make sure all the set up info is correct ".
            "and you have forums set up, etc. ".
            "If you are a member and got this error, panic! or just wait until the admin".
            " fixes it."                                           if $msg =~ /DB Error/;
    $help = "Matt screwed up again, ha!"                           if $msg =~ /Undefined subroutine/;
    $help = "Matt needs to learn perl"                             if $msg =~ /Bareword/;
    $help = "I can't write into that directory, please check ".
            "the CHMOD value on the directory path above,".
            " if in doubt, use 0777"                               if $msg =~ /Permission denied/i;

    $help = "Nothing of interest" unless $help;

    print $iB::CGI->header() unless $iB::CONTENT->{'HTTP'} == 1;
    print qq~
    <html>
    <head><title>Ikonboard CGI Error</title></head>
    <body bgcolor='#FFFFFF'>
    <font face='Trebuchet MS, Verdana, Arial' size='6' color='#333366'>Ikonboard CGI Error</font>
    <hr size='1' color='#000000' noshade>
    <font face='arial, verdana' size='3' color='#00000'>
    Ikonboard has exited with the following error:
    <br><br><b>$msg</b><br><br>This error was reported at: <font color='#000099' face='Courier, Courier New, Verdana, Arial'>$path</font>
    <br><br>
    <b>Ikonboard says...</b><br><br>
    $help
    <br><br><font size='3' color='#990000'><b>Please note that your 'real' paths have been removed to protect your information.</b></font>
     
    </font>
    </body>
    </html>
    ~;

    exit (0);
    
}




sub ValidateEntry {
  my $obj = shift;
  return unless lc($ENV{'REQUEST_METHOD'}) eq 'post';
  my $b_url = $INFO->{'BOARD_URL'} =~ m!^http\:!i ?  (split /\/\//, $INFO->{'BOARD_URL'})[1]
                                                  :  $INFO->{'BOARD_URL'};

  $obj->Error(LEVEL=>'5',MESSAGE=>'referrer_fail') unless $ENV{'HTTP_REFERER'} =~ m!$b_url!i;

}


sub unHTML {
    my ($obj, $Tmp) = @_;
    return $obj->CleanValue($Tmp);
}

sub doHTML {
    my $obj = shift;
    my $Tmp = $_[0];
    $Tmp =~ s/&#39;/'/g;    $Tmp =~ s/\&lt;/</g;     $Tmp =~ s/\&gt;/>/g;
    $Tmp =~ s!&#36!\$!g;    $Tmp =~ s/&#124;/\|/g;   $Tmp =~ s/&#43;/\+/g;
    $Tmp =~ s/&#42;/\*/g;   $Tmp =~ s/&#41;/\)/g;    $Tmp =~ s/&#40;/\(/g;
    $Tmp =~ s/&#44;/,/g;    $Tmp =~ s/&#125;/\}/g;   $Tmp =~ s/&#123;/\{/g;
    $Tmp =~ s/&#92;/\\/g;   $Tmp =~ s/&quot;/"/g;    $Tmp =~ s/&amp;/&/g;
    return $Tmp;
}



sub TextTidy {
    my $obj = shift;
    my $Tmp = $_[0];
    $Tmp =~ s!  ! &nbsp;!g;  $Tmp =~ s!\t!&nbsp;&nbsp;!g; $Tmp =~ s!\\n!&#92;n!g;
    $Tmp =~ s!\r!\n!g;       $Tmp =~ s!\n\n!\n!g;
    return $obj->doHTML($Tmp);
}


sub CleanKey {
    my ($obj, $key) = @_;
    return unless defined $key;
    $key =~ s!\0!!g;
    $key =~ s!\.\.!!g;
    $key =~ s!\_\_(.+?)\_\_!!g;
    $obj->_trim($key);
    $key =~ m!^([\w\.-]+)$!;
    return $1;
}

sub CleanValue {
    my ($obj, $Tmp) = @_;
    $Tmp =~ s!\0!!g;
    $Tmp =~ s|&|&amp;|g;
    $Tmp =~ s|<!--|&#60;&#33;--;|g;
    $Tmp =~ s|-->|--&#62;|g;
    $Tmp =~ s|<script>|&#60;script&#62;|ig;
    $Tmp =~ s|>|&gt;|g;
    $Tmp =~ s|<|&lt;|g;
    $Tmp =~ s|"|&quot;|g;
    $Tmp =~ s|  | &nbsp;|g;
    $Tmp =~ s!\|!&#124;!g;
    $Tmp =~ s|\{|&#123;|g;
    $Tmp =~ s|\}|&#125;|g;   
    $Tmp =~ s|'|&#39;|g;
    $Tmp =~ s|\n|<br>|g;
    $Tmp =~ s|\s+$||g;
    $Tmp =~ s|\$|&#36;|g;
    $Tmp =~ s|\r||g;
    $Tmp =~ s|\_\_(.+?)\_\_||g;
    $Tmp =~ s|\\|&#92;|g;
    $Tmp =~ s|!|&#33;|g;
    return $Tmp;
}

sub IsNumber {
    my ($obj, $num) = @_;
    return unless defined $num;
    $num =~ s!\.\.!!g;
    $num =~ m!^(\d+)$!;    
    return $1;
}

sub IsWord {
    my ($obj, $word) = @_;
    return unless defined $word;
    $word =~ s!\0!!g;
    $word =~ s!\.\.!!g;
    $word =~ m!^(\w+)$!;
    return $1;   
}

sub CheckCodeNo {
    my $obj = shift;
    return unless defined $_[0];
    my $Return = $obj->IsNumber($_[0]);
    $obj->Error(LEVEL=>'5',MESSAGE=>'Incorrect Ikonboard action code number') if length($Return) != 2;
    return $Return;
}

sub CheckEmail {
    my ($obj, $Email) = @_;
    $Email =~ s![\n\r\*\'\"<>&\%\\!\(\)\{\}\[\]\?\\/]!!isg;
    $Email = $obj->unHTML($Email);
    return $Email =~ /^.+\@(\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,3}|[0-9]{1,3})(\]?)$/ ?  1 : return 0;
}


sub _trim {
  my $obj = shift;
  my @tr = @_;
  return unless @_;
  for (@tr) { s!^\s+!!; s!\s+$!!; }
  return wantarray ? @tr : $tr[0];
}


sub GetDate {

}

sub get_date {
    my $obj = shift;

    my %IN = ( TIME => "", METHOD => "", @_,);

    return '--' unless defined $IN{'TIME'};

    $IN{'TIME'}= $IN{'TIME'} + ($INFO->{'TIME_ZONE'} * 3600) + ($iB::MEMBER->{'TIME_ADJUST'} * 3600);
    my $tm = localtime($IN{'TIME'});
    my $r_time;

    my %Return;
    $Return{'YEAR'}          = $tm->year+1900;
    $Return{'MONTH_NUMBER'}  = $tm->mon+1;
    $Return{'MONTH_NAME'}    = $Universal::lang->{'Months'}->{$tm->mon+1};
    $Return{'DATE_NUMBER'}   = $tm->mday;
    $Return{'DAY_NAME'}      = $Universal::lang->{'Days'}->{$tm->wday};
    $Return{'HOUR'}          = $tm->hour;
    $Return{'MIN'}           = $tm->min;
    $Return{'MIN'}           = "0$Return{'MIN'}"          if length($Return{'MIN'})   == 1;
    $Return{'HOUR'}          = "0$Return{'HOUR'}"         if length($Return{'HOUR'})  == 1;
    $Return{'DATE_NUMBER'}   = "0$Return{'DATE_NUMBER'}" if length($Return{'DATE_NUMBER'}) == 1;

    if ($iB::INFO->{'CLOCK_TYPE'} eq '12h') {
        if ($Return{'HOUR'} > 12) {
            $Return{'SUFFIX'} = 'pm';
            $Return{'HOUR'} -= 12;
        } else {
            $Return{'SUFFIX'} = 'am';
        }
    }

    my ($joined, $short, $long) = split /\|&\|/, $iB::INFO->{'CLOCK_STYLE'};

    $r_time = $joined if $IN{'METHOD'} eq 'JOINED';
    $r_time = $short  if $IN{'METHOD'} eq 'SHORT';
    $r_time = $long   if $IN{'METHOD'} eq 'LONG';

    for (keys %Return) {
        $r_time =~ s!$_!$Return{$_}!;
    }

    return $r_time;
}
        

      
sub Error {
    my $obj = shift;
    my %IN  = ( DB       => "",
                LEVEL    => "",
                MESSAGE  => "",
                EXTRA    => "",
                @_,
              );

    $iBoard::lang = $obj->LoadLanguage('ErrorWords');

    $iBoard::lang->{'log_in_msg'} = $iB::MEMBER->{'MEMBER_ID'} ? $iBoard::lang->{'log_in_yes'} . $iB::MEMBER->{'MEMBER_NAME'}
                                                               : $iBoard::lang->{'log_in_no'};

    if ($IN{'EXTRA'}) {
        $iBoard::lang->{ $IN{'MESSAGE'} } = s!<#VAR#>!$IN{'EXTRA'}!g;
    }

    my $print = Universal::Error( $iBoard::lang->{ $IN{'MESSAGE'} } );

    my $output = FUNC::Output->new()->print_ikonboard( DB         => $IN{'DB'},
                                                       STD        => $obj,
                                                       TITLE      => 'iB::Error',
                                                       NAV_ONE    => 'Error Message',
                                                       JAVASCRIPT => 1,
                                                       OUTPUT     => $print
                                                     );

}

  

sub MaintenanceMode {

}


sub ForumJump ($) {
    my $obj = shift;
    my $html = qq[ <form action='$INFO->{'BOARD_URL'}/ikonboard.$INFO->{'CGI_EXT'}' method='post' name='jump'>
                   <select name='jump' onchange="jumpMenu('parent',this,0)" class='forminput'>
                   <option value="$INFO->{'BOARD_URL'}/ikonboard.$INFO->{'CGI_EXT'}">Forum Jump
                   <option value="$INFO->{'BOARD_URL'}/ikonboard.$INFO->{'CGI_EXT'}">-----------
                 ];

    return 0 unless (-e $iB::PTH.'/Data/ForumJump.pm');
    
    require 'Data/ForumJump.pm';
    my $Forums = ForumJump->new();

    for (sort { $a <=> $b } keys %{$Forums}) {
        if ($Forums->{$_}[0] eq 'c') {
            if ($Forums->{$_}[3] ne '*') {
                next unless grep { $_ == $iB::MEMBER->{'MEMBER_GROUP'} } (split (/,/, $Forums->{$_}[3]) );
            }
            my $dash = '-' x length($Forums->{$_}[2]);
            $html .= qq[<option value="$INFO->{'BOARD_URL'}/ikonboard.$INFO->{'CGI_EXT'}">&nbsp;\n
                        <option value="$INFO->{'BOARD_URL'}/ikonboard.$INFO->{'CGI_EXT'}?act=SC;c=$Forums->{$_}[1]">&gt;$Forums->{$_}[2]\n
                        <option value="$INFO->{'BOARD_URL'}/ikonboard.$INFO->{'CGI_EXT'}">&nbsp;&nbsp;$dash\n
                       ];
        } elsif ($Forums->{$_}[0] eq 'f') {
            if ($Forums->{$_}[3] ne '*') {
                next unless grep { $_ == $iB::MEMBER->{'MEMBER_GROUP'} } (split (/,/, $Forums->{$_}[3]) );
            }
            $html .= qq[<option value="$INFO->{'BOARD_URL'}/ikonboard.$INFO->{'CGI_EXT'}?act=SF;f=$Forums->{$_}[1]">&nbsp;&nbsp;&nbsp;+- $Forums->{$_}[2]\n];
        }
    }
    return $html .= qq[</select></form>\n];
}


sub ib_int {
  my ($obj, $x, $y) = @_;

  return unless ($x and $y);

  if (($x % $y) == 0) {
    return $x / $y;
  } else {
    return int ($x / $y + 1);
  }
}


#+---------------------------------------------------------------------------------------------------------------------
#+---------------------------------------------------------------------------------------------------------------------
# OUTPUT MODULE

package FUNC::Output;
use strict;
$iB::MEMBER->{'LANGUAGE'} ||= 'en';
$iB::SKIN = FUNC::STD->LoadSkin();
require $iB::SKIN->{'DIR'} . '/Universal.pm' or die $!;

sub new {
    my $pkg = shift;
    my $obj = {};
    bless $obj, $pkg;
    return $obj;
}


sub print_popup {
    my $obj = shift;
    my $IN = {  
                "STD"           => "",
                "OUTPUT"        => "",
                "TITLE"         => "",
                @_
              };

    $obj->print_http_header();

    print qq~
    <html>
    <head>
        <title>$IN->{'TITLE'}</title>
        <link type="text/css" href="$iB::INFO->{'IMAGES_URL'}/ikonboard.css" rel="stylesheet">
        <!-- Output Generated by Ikonboard &copy; 2001 Jarvis Entertainment Group -->
    </head>
    <body topmargin='0' leftmargin='0' rightmargin='0' marginwidth='0' marginheight='0'  alink='#000000' vlink='#000000'>

    <!-- Begin Pooled Output -->

    $IN->{'OUTPUT'}

    <!-- End Pooled Ouput -->
    </body>
    </html>
    ~;

    return 1;
}


sub board_offline {
    my $obj = shift;
    my $IN = {  
                "DB"            => "",
                "STD"           => "",
                @_,
             };

    $obj->print_http_header();
    print Universal::Offline($iB::INFO->{'OFFLINE_MESSAGE'});
}



sub print_ikonboard {
    my $obj = shift;
    my $IN = {  
                "DB"            => "",
                "STD"           => "",
                "OUTPUT"        => "",
                "SPELLCHECKER"  => "",
                "JAVASCRIPT"    => "",
                "TITLE"         => "",
                "NAV"           => undef,
                "NAV_ONE"       => "",
                "NAV_TWO"       => "",
                "OVERRIDE"      => "",
                @_
              };


    $iB::TT1 = new Benchmark;

                         #my $ikonboard_js = ($iB::INFO->{'SPELL_CHECKER'} eq 'on' and $IN->{'SPELLCHECKER'} ne '')
                         #? qq[<script type="text/javascript" language="javascript" src="$iB::INFO->{'SPELL_CHECKER_DIR'}/spch.js"></script>] : "";

    my $ikonboard_js = $IN->{'JAVASCRIPT'} ne '' ? qq[\n<script src="$iB::INFO->{'IMAGES_URL'}/ikonboard.js" type="text/javascript"></script>] : "";
    
    my $BCopy = $iB::INFO->{'COPYRIGHT_INFO'} ? qq!&copy; $iB::INFO->{'COPYRIGHT_INFO'}!
                                              : "";

    my $td = Benchmark::timediff($iB::TT1,  $iB::TT0);
    my $stats = "<br><center><font class='misc'>Admin Stats: Execution took " . Benchmark::timestr($td) . "  </center></font>\n";

    my $ib_copy = qq~
                <!-- iB Copyright Information -->
                <p>
                <table width=80% align=center cellpadding=3 cellspacing=0>
                    <tr>
                        <td align=center valign=middle>
                            <font class="copyright">
                            $BCopy<br>
                            Powered by <a href="http://www.ikonboard.com" class="copyright" target='_blank'>Ikonboard</a> $iB::VERSION &copy; 2001 <a href='http://www.jarvisgroup.net' class='copryright' target='_blank'>Jarvis Entertainment Group, Inc.</a>
                            </font>
                        </td>
                    </tr>
                </table>
                <p>
                ~;

    local $/ = undef;
    open FH, $iB::INFO->{'TEMPLATE_DIR'}.'global_template.html' or $IN->{'STD'}->cgi_error("Could not open the Template File: $!");
    my $it = <FH>;
    close FH or die "Could not close that file: $!";

    $iB::APPEND_SEARCH = $iB::IN{'f'} ? "f=$iB::IN{'f'}" : '';

    $it =~ s!<% TITLE %>!$IN->{'TITLE'}!i;
    $it =~ s!<% GENERATOR %>!<meta name="GENERATOR" content="Ikonboard $iB::VERSION">!i;
    $it =~ s!<% IB CSS %>!<link type="text/css" href="$iB::SKIN->{'IMAGES_URL'}/ikonboard.css" rel="stylesheet">!i;
    $it =~ s!<% IB JAVASCRIPT %>!$ikonboard_js!is;
    $it =~ s!<% BOARD HEADER %>!Universal::BoardHeader()!ie;
    unless ($iB::IN{'OVERRIDE'}) {
        $it =~ s!<% MEMBER BAR %>!$obj->member_bar($IN->{'DB'})!ieg;
        $it =~ s!<% NAVIGATION %>!$obj->navigation($IN)!ieg;
    } else {
        $it =~ s!<% MEMBER BAR %>!!ig;
        $it =~ s!<% NAVIGATION %>!!ig;
    }
    $it =~ s!<% COPYRIGHT %>!$ib_copy!ig;
    $it =~ s!<% STATS %>!$stats!ig if $iB::MEMBER->{'MEMBER_GROUP'} == $iB::INFO->{'SUPAD_GROUP'};
    $it =~ s!<% IKONBOARD %>!$IN->{'OUTPUT'}!i;

    $obj->print_http_header();

    # So, after many modules, routines, checks, regex's and other magic,
    # all it takes is two words to make ikonboard appear....


    print $it;




    # ... talk about an anti-climax.

exit;
}

    
sub redirect_screen {
    my $obj = shift;
    my $IN = {  
                "TEXT"          => "",
                "URL"           => "",
                @_
              };
    
    $IN->{'URL'} = "?s=$iB::SESSION;".$IN->{'URL'};

    $obj->print_http_header();
    print Universal::Redirect($IN->{'TEXT'}, $IN->{'URL'});
                          
}


sub pure_redirect {
   my $obj = shift;
   my $IN  = { URL => "", @_, };

   $IN->{'URL'} = "$iB::INFO->{'BOARD_URL'}/ikonboard.$iB::INFO->{'CGI_EXT'}?s=$iB::SESSION;".$IN->{'URL'};
   print $iB::CGI->redirect( URL => $IN->{'URL'}, COOKIES => $iB::COOKIES_OUT );
   $iB::CONTENT->{'HTTP'} = 1;
}


sub print_http_header {
    my $obj = shift;
    unless ($iB::CONTENT->{'HTTP'} == 1) {
        print $iB::CGI->header( COOKIES => $iB::COOKIES_OUT );
        $iB::CONTENT->{'HTTP'} = 1;
    }
    return 1;
}


sub navigation {
    my ($obj, $IN) = @_;
    if ($IN->{'NAV'}) {
        my $return = qq|<a href="$iB::INFO->{'BOARD_URL'}/ikonboard.cgi?s=$iB::SESSION" class="nav">$iB::INFO->{'BOARDNAME'}</a>|;
        for ( @{ $IN->{'NAV'} } ) {
            $return .= $Universal::nav_seperator . $_;
        }
        return $Universal::nav_start . $return . $Universal::nav_end;
    }

    else { return Universal::Navigation($IN->{'NAV_ONE'}, $IN->{'NAV_TWO'}) }
}

sub member_bar {
    my ($obj, $db) = @_;
    if ($iB::MEMBER->{'MEMBER_ID'} == 0 or $iB::MEMBER->{'MEMBER_ID'} eq '') {
        return Universal::Guest_bar();
    } else {
        my $msg_data = $db->select( TABLE   => 'message_stats',
                                    KEY     => $iB::MEMBER->{'MEMBER_ID'},
                                    ID      => $iB::MEMBER->{'MEMBER_ID'},
                                    COLUMNS => ['NEW_MESSAGES']
                                  );
        my $admin_link = $iB::MEMBER_GROUP->{'ACCESS_CP'} ? qq[:: <a href='$iB::INFO->{'BOARD_URL'}/ikonboard.$iB::INFO->{'CGI_EXT'}?s=$iB::SESSION&AD=1'>$Universal::lang->{'admin_cp'}</a>]
                                                              : '';
        $msg_data->{'ICON'} = $msg_data->{'NEW_MESSAGES'} ? 'msg_new_bar.gif' : 'msg_no_new_bar.gif';
        $msg_data->{'NEW_MESSAGES'} ||= 0;
        $msg_data->{'TEXT'} = $Universal::lang->{'msg_new'};
        $msg_data->{'TEXT'} =~ s!<#NEW_MESSAGES#>!$msg_data->{'NEW_MESSAGES'}!;
        return Universal::Member_bar($msg_data, $admin_link);
    }
}


#+---------------------------------------------------------------------------------------------------------------------
#+---------------------------------------------------------------------------------------------------------------------
# MEMBER MODULE


package FUNC::Member;

use Lib::Crypt;
use strict;

sub new {
    my $pkg = shift;
    my $obj = {};
    bless $obj, $pkg;
    return $obj;
}


sub AddMember {
    my $obj = shift;

    my $IN  = { DB     => "",
                STD    => "",
                MEMBER => "",
                @_,
              };

    $IN->{'STD'}->cgi_error("No Name was selected!") unless $IN->{'MEMBER'};

    my $Time = time;

    my $IdPart   = $obj->convert_to_num($IN->{'MEMBER'}->{'MEMBER_NAME'});
    my $Insert   = { MEMBER_NAME => $IN->{'MEMBER'}->{'MEMBER_NAME'},
                     MEMBER_ID   => "$IdPart".'-'."$Time",
                   };

    $IN->{'MEMBER'}->{'MEMBER_EMAIL'}    = lc($IN->{'MEMBER'}->{'MEMBER_EMAIL'});
    $IN->{'MEMBER'}->{'MEMBER_ID'}       = $Insert->{'MEMBER_ID'};
    $IN->{'MEMBER'}->{'MEMBER_PASSWORD'} = $obj->Crypt($IN->{'MEMBER'}->{'MEMBER_NAME'}, $IN->{'MEMBER'}->{'MEMBER_PASSWORD'});


    $IN->{'DB'}->insert( TABLE  => 'member_profiles',
                         ID     => $IN->{'MEMBER'}->{'MEMBER_ID'},
                         VALUES => $IN->{'MEMBER'}
                       );

    $IN->{'DB'}->update_index( TABLE     => 'member_profiles',
                               INDEX_KEY => 'MEMBER_EMAIL',
                               R_KEY     => $IN->{'MEMBER'}->{'MEMBER_EMAIL'},
                               R_VALUE   => $IN->{'MEMBER'}->{'MEMBER_ID'}
                     );

    $IN->{'DB'}->update_index( TABLE     => 'member_profiles',
                               INDEX_KEY => 'MEMBER_NAME',
                               R_KEY     => $IN->{'MEMBER'}->{'MEMBER_NAME'},
                               R_VALUE   => $IN->{'MEMBER'}->{'MEMBER_ID'}
                     );

    return $Insert->{'MEMBER_ID'};
}

#+------------------------------------------------------------------------------------------------------

sub convert_to_chr {
    my $obj = shift;
    return unless defined $_[0];
    return chr $_[0];
}

#+------------------------------------------------------------------------------------------------------

sub convert_to_num {
    my $obj = shift;
    return unless defined $_[0];
    my $Name = substr($_[0], 0, 1);
    return ord $Name;
} 

#+------------------------------------------------------------------------------------------------------

sub GetLetter {
    my $obj = shift;
    my $Name = $_[0];
    return unless defined $Name;
    my $N = substr($Name, 0, 1);
    my %RETURN;
    $RETURN{'LETTER'} = $N;
    if (uc($RETURN{'LETTER'})  =~ /^[A-Z0-9]+$/) {
        $RETURN{'CHR'} = uc($N);
    } else {
        $RETURN{'CHR'} = 'chr';
    }
    return \%RETURN;
}

#+------------------------------------------------------------------------------------------------------

sub CheckMemberTitles ($$) {
    my ($obj, $MemberInfo) = @_;
    use MemberTitles;
    my $Amount = MemberTitles->new();
    foreach ( sort { $Amount->{$b}[0] <=> $Amount->{$a}[0] } keys %$Amount) {
    if (($MemberInfo->{'MEMBER_POSTS'} >= $Amount->{$_}[0]) && ($_ < 80) && ($Amount->{$_}[0] =~ /[0-9]/)) {
        $MemberInfo->{'MEMBER_LEVEL'} = $_;
    last;
    }
  }
  return $MemberInfo;
}

#+------------------------------------------------------------------------------------------------------

sub CheckName  {
    my $obj = shift;
    my $IN  = { DB   => "",
                NAME => "",
                @_,
              };

        
    return  $IN->{'DB'}->query( TABLE    =>'member_profiles',
                                INDEX    => { KEY   => 'MEMBER_NAME',
                                              VALUE => $IN->{'NAME'},
                                              CASE  => 1
                                            },
                              );
}

sub Check_Mem_Email  {
    my $obj = shift;
    my $IN  = { DB    => "",
                EMAIL => "",
                @_,
              };

    $IN->{'EMAIL'} = lc($IN->{'EMAIL'});

    return $IN->{'DB'}->query(  TABLE    => 'member_profiles',
                                INDEX    => { KEY => 'MEMBER_EMAIL', VALUE => $IN->{'EMAIL'} },
                             );

}


#+------------------------------------------------------------------------------------------------------

sub LoadMember {
    my $obj = shift;
    my $IN  = { DB     => "",
                KEY    => "",
                METHOD => "",
                @_,
              };
    return {} unless defined $IN->{'KEY'};

    my $db  = $IN->{'DB'};
    my $key = $IN->{'KEY'};
    my $Info = { MEMBER_ID => '' };
    
    if ($IN->{'METHOD'} eq 'by id') {
        $Info = $db->select(TABLE => 'member_profiles', ID => $key, KEY => $key);
    } else {
        $Info = $db->query(  TABLE    =>'member_profiles', 
                             INDEX    => { KEY => 'MEMBER_NAME', VALUE => $key },
                          );
    }
    return $Info->{'MEMBER_ID'} ne '' ? $Info : $obj->SetUpGuest();
}

#+------------------------------------------------------------------------------------------------------

sub UpdateMember  {
    my $obj = shift;
    my $IN = { DB      => "",
               MEMBER  => "",
               @_,
             };
    my $db = $IN->{'DB'};
    my $pkg = (caller(0))[0];
    $IN->{'MEMBER'} = $obj->CheckMemberTitles($IN->{'MEMBER'}) if ($pkg eq 'Post') and ($IN->{'MEMBER'}->{'MEMBER_LEVEL'} < 79);  
    $db->update( TABLE   => 'member_profiles',
                 VALUES  => $IN->{'MEMBER'},
                 ID      => $IN->{'MEMBER'}->{'MEMBER_ID'},
                 KEY     => $IN->{'MEMBER'}->{'MEMBER_ID'}
               ); 
}

#+------------------------------------------------------------------------------------------------------

sub Crypt {
    my $obj = shift;
    my ($Name, $Pass) = @_;
    return unless ($Name or $Pass);
    return crypt ($Pass, lc (substr($Name, 0, 2 )));
} 

#+------------------------------------------------------------------------------------------------------

sub SetUpGuest ($$) {
   my ($obj, $g_name) = @_;
   $g_name ||=  'Guest';

   return {
            MEMBER_NAME      => $g_name,
            MEMBER_PASSWORD  => '',
            MEMBER_ID        => '',
            MEMBER_AVATAR    => 'noavatar',
            MEMBER_TITLE     => 'UNREGISTERED',
            MEMBER_LEVEL     => -1,
            MEMBER_GROUP     => $iB::INFO->{'GUEST_GROUP'},
            MEMBER_POSTS     => 'N/A',
            MEMBER_EMAIL     => undef,
            MEMBER_WEB       => undef,
            GUEST            => 1,
            VIEW_AVS         => 1,
            VIEW_IMG         => 1,
            VIEW_SIGS        => 1,
            IP_ADDRESS       => $ENV{'REMOTE_ADDR'}
         };

}

#+------------------------------------------------------------------------------------------------------

sub RandomPassword {
  my $obj = shift;
  my @Chars = (
    "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m",
    "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z",
    "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M",
    "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z",
    "1", "2", "3", "4", "5", "6", "7", "8", "9", "0"
    );
  my $Password;
  srand (time);
  for (my $i = 0; $i < 8; $i++) {
    $Password .= $Chars[ int ( rand ( $#Chars + 1 ) ) ];
  }
  return $Password;
}




#+------------------------------------------------------------------------------------------------------
#+------------------------------------------------------------------------------------------------------
# MAILER MODULE

package FUNC::Mailer;
use strict;
BEGIN {
    require 'Boardinfo.pm' or die "Cannot load Module: $!";
    use MIME::Lite;
    require 'iTextparser.pm';
}

$iB::INFO = Boardinfo->new();
my $std   = FUNC::STD->new();
my $txt   = iTextparser->new();


sub new {
  my $pkg = shift;
  my $obj = {};
  bless $obj, $pkg;
  return $obj;
}


sub parse_template  {
    my $obj = shift;
    my %IN  = ( DB     => "",
                ID     => "",
                VALUES => {},
                @_,
              );

    my $words   = $IN{'VALUES'};

    my $ext     = $iB::INFO->{'EMAIL_CONTENT'} eq 'html' ? '_h' : '';

    my $email   = $iB::INFO->{'EMAIL_HEADER'};

    my $content = $IN{'DB'}->select( TABLE   => 'email_templates',
                                     KEY     => $IN{'ID'}.$ext
                                   ) || die $IN{'DB'}->{'error'};

    $email .= $content->{'TEMPLATE'} ."\n" . $iB::INFO->{'EMAIL_FOOTER'};

    $words->{'BOARD_ADDRESS'}  = $iB::INFO->{'BOARD_URL'} . '/ikonboard.' . $iB::INFO->{'CGI_EXT'};
    $words->{'WEB_ADDRESS'}    = $iB::INFO->{'HOME_URL'};
    $words->{'BOARD_NAME'}     = $iB::INFO->{'BOARDNAME'};
    $words->{'SIGNATURE'}      = $iB::INFO->{'SIGNATURE'};
 
    for (keys %{$words}) { $email =~ s!<#(.+?)#>!$words->{$1}!sg }
 
    return $txt->Convert_for_email($email);
}
   
   

sub Send ($) {
    my $obj = shift;
    $obj->{'ARGS'} = { TO=>"",FROM=>"",BCC=>[],SUBJECT=>"",MESSAGE=>"",MSG_ID=>"",CC=>"",@_,};
    die  "Not Enough Parameters!" unless ($obj->{'ARGS'}->{'TO'} or $obj->{'ARGS'}->{'BCC'})
                                     and  $obj->{'ARGS'}->{'SUBJECT'}
                                     and  $obj->{'ARGS'}->{'MESSAGE'};
    $obj->{'ARGS'}->{'FROM'} = $iB::INFO->{'ADMIN_EMAIL_OUT'} unless $obj->{'ARGS'}->{'FROM'};
    $obj->_unfold_bcc() if exists $obj->{'ARGS'}->{'BCC'};
    
    my $mail = MIME::Lite->new(
                                To      => $obj->{'ARGS'}->{'TO'},
                                From    => $obj->{'ARGS'}->{'FROM'},
                                cc      => $obj->{'ARGS'}->{'CC'},
                                Bcc     => $obj->{'ARGS'}->{'BCC'},
                                Subject => $obj->{'ARGS'}->{'SUBJECT'},
                                Type    => 'multipart/alternative'
                              );
    $mail->attach( Type => 'text/plain', Data => $obj->{'ARGS'}->{'MESSAGE'} );

    my $mail_type = $iB::INFO->{'EMAIL_TYPE'} eq 'send_mail' ? 'sendmail' : 'smtp';
    my $mail_prog = $mail_type eq 'sendmail' ? qq!$iB::INFO->{'SEND_MAIL'} -t -io! : $iB::INFO->{'SMTP_SERVER'};

    die "Insufficent data to connect to mail server" unless $mail_type and $mail_prog;

    $mail->send($mail_type, $mail_prog);

}



sub _unfold_bcc ($) {
    my $obj = shift;
    $obj->{'ARGS'}->{'BCC'} = wantarray ? join ', ',@{ $obj->{'ARGS'}->{'BCC'} } : $obj->{'ARGS'}->{'BCC'};
}

sub my_gen_id {
    my $obj = shift;
    srand($$|time);
    my $session = int(rand(60000000));
    return unpack("H*", pack("Nnn", time, $$, $session));

}


#+------------------------------------------------------------------------------------------------------
#+------------------------------------------------------------------------------------------------------
# END OF MODULES
1;
__END__

 
