package LogInOut;
use strict;
#+------------------------------------------------------------------------------------------------------
BEGIN { require 'Lib/FUNC.pm'; }

my $std    = FUNC::STD->new();
my $mem    = FUNC::Member->new();
my $output = FUNC::Output->new();


$LogInOut::lang = $std->LoadLanguage('LoginWords');
#+------------------------------------------------------------------------------------------------------

sub new {
    my $pkg = shift;
    my $obj = {};
    bless $obj, $pkg;
    return $obj;
}

#+------------------------------------------------------------------------------------------------------

sub LogIn {
    my ($obj, $db) = @_;

    $std->Error(LEVEL=>'1',MESSAGE=>'poss_hack_attempt')       unless ($iB::IN{'Privacy'} == 0 or $iB::IN{'Privacy'} == 1);

    $std->Error( LEVEL => 1, 'no_username') unless $iB::IN{'UserName'};
    $std->Error( LEVEL => 1, 'pass_blank')  unless $iB::IN{'PassWord'};



    my $url;
    if ($iB::COOKIES->{$iB::INFO->{'COOKIE_ID'}.'iBredirect'} and ($iB::IN{'act'} ne 'Reg' or $iB::IN{'act'} ne 'LostPass')) {
        $url = $iB::COOKIES->{$iB::INFO->{'COOKIE_ID'}.'iBredirect'};
        #$url =~ s
        $url =~ s!\|!=!g;
        $url =~ s!\?!!g;
        $url =~ s!s=.+?[&;]!!g;
        $url = '' if $url =~ /LostPass/i;
    }
    $output ->redirect_screen( TEXT  => "$LogInOut::lang->{'thanks_for_login'} $iB::MEMBER->{'MEMBER_NAME'}",
                               URL   => $url
                             );
  
}








sub DoLogOut {
    my ($obj, $db) = @_;

    $std->Error(LEVEL=>'1',MESSAGE=>'no_guests') unless $iB::MEMBER->{'MEMBER_ID'};

    $db->update( TABLE  => 'active_sessions',
                 KEY    => $iB::SESSION,
                 VALUES => { ID               =>  $iB::SESSION,
                             MEMBER_NAME      =>  "",
                             MEMBER_PASSWORD  =>  "",
                             MEMBER_ID        =>  "",
                             THIS_IP          =>  $ENV{'REMOTE_ADDR'},
                             LAST_LOG_IN      =>  time,
                             USER_AGENT       =>  $ENV{'HTTP_USER_AGENT'},
                             SESSION_START    =>  time,
                             MEMBER_LOGSTATE  =>  1,
                             LOCATION         =>  $iB::IN{'act'}."|&|".$ENV{'QUERY_STRING'},
                             LOG_IN_TYPE      =>  $iB::IN{'Privacy'}
                           }
                );

    push @{$iB::COOKIES_OUT}, $iB::CGI->cookie( NAME => $iB::INFO->{'COOKIE_ID'}.'iBSessionID', VALUE => $iB::SESSION, EXPIRES => '+1d', PATH => $iB::INFO->{'COOKIE_PATH'});
    push @{$iB::COOKIES_OUT}, $iB::CGI->cookie( NAME => $iB::INFO->{'COOKIE_ID'}.'iBMemberID',  VALUE => '-', EXPIRES=>'-1d', PATH => $iB::INFO->{'COOKIE_PATH'} );
    push @{$iB::COOKIES_OUT}, $iB::CGI->cookie( NAME => $iB::INFO->{'COOKIE_ID'}.'iBPassWord',  VALUE => '-', EXPIRES=>'-1d', PATH => $iB::INFO->{'COOKIE_PATH'} );
    
    $output->redirect_screen( TEXT      => "$LogInOut::lang->{'thanks_for_logout'}",
                              URL       => ''
                            );    

}





sub ShowForm  {
    my ($obj, $db) = @_;
    require $iB::SKIN->{'DIR'} . '/LogInView.pm' or die $!;

    my $cookie = $ENV{'HTTP_REFERER'};
    $cookie =~ s#$iB::INFO->{'BOARD_URL'}/ikonboard\.$iB::INFO->{'CGI_EXT'}##;
    $cookie =~ s#$iB::INFO->{'BOARD_URL'}##gi;
    $cookie =~ s#/##gi;
    $cookie =~ y!;!&!;
    $cookie =~ s!s=.+?[&;\Z]!!g;
    $cookie =~ s!=!\|!g;
    push @{$iB::COOKIES_OUT}, $iB::CGI->cookie( NAME=> $iB::INFO->{'COOKIE_ID'}.'iBredirect', VALUE => $cookie, PATH => $iB::INFO->{'COOKIE_PATH'} );

    $output->print_ikonboard(
                              DB      => $db,
                              STD     => $std,
                              OUTPUT  => &LogInView::ShowForm($LogInOut::lang->{'please_log_in'}),
                              TITLE   => 'iB::'.$LogInOut::lang->{'log_in'},
                              NAV_ONE => 'Logging In'
                            );
    
}

sub ShowLogOut  {
    my ($obj, $db) = @_;
    require $iB::SKIN->{'DIR'} . '/LogInView.pm' or die $!;
    $output->print_ikonboard(
                              DB      => $db,
                              STD     => $std,
                              OUTPUT  => &LogInView::ShowLogOutForm(),
                              TITLE   => 'iB::'.$LogInOut::lang->{'log_in'},
                              NAV_ONE => 'Logging In'
                            );
}



sub Process {
    my ($obj, $db) = @_;
    my $CodeNo = $std->CheckCodeNo($iB::IN{'CODE'});
    my %Mode = ( '01'     => \&LogIn,
                 '00'     => \&ShowForm,
                 '02'     => \&ShowLogOut,
                 '03'     => \&DoLogOut
               );
    $Mode{$CodeNo} ? $Mode{$CodeNo}->($obj, $db) : LogInError($obj, $db);   
} 

sub LogInError  { my ($obj, $db) = @_; $std->Error(LEVEL=>'1',MESSAGE=>'no_action') }

1;


__END__
