package MailFunctions;

#+------------------------------------------------------------------------------------------------------
#| Ikonboard by Matthew Mecham [ v3.0 ]
#|
#| No parts of this script can be used outside Ikonboard without prior consent.
#| You must keep this header intact and all copyright links visable.
#| (c)2001 Ikonboard.com <http://www.ikonboard.com>
#|
#| Please Read the licence for more information.
#+------------------------------------------------------------------------------------------------------

use Carp;
use Boardinfo;
use iMailer;
use Makelog;
use iBoard;
#+------------------------------------------------------------------------------------------------------
use strict;
#+------------------------------------------------------------------------------------------------------
my $std   = iBoard->new();
my $INFO  = Boardinfo->new();
my $SEND  = iMailer->new();
$MailFunctions::lang = $std->LoadLanguage('MailFunctionsWords');
#+------------------------------------------------------------------------------------------------------

sub new {
    my $pkg = shift;
    my $obj = {};
    bless $obj, $pkg;
    return $obj;
}

#+------------------------------------------------------------------------------------------------------

sub invite_friend ($) {
    my $obj = shift;
    #+------------------------------------------------------------------------------------
    $std->Error(LEVEL=>'2', MESSAGE=>'no_guests')         if $iB::MEMBER->{'MEMEBR_STATE'} eq 'Guest';
    $std->Error(LEVEL=>'2', MESSAGE=>'invite_no_name')    unless $iB::IN{'SenderName'};
    $std->Error(LEVEL=>'2', MESSAGE=>'invite_no_email')   unless $iB::IN{'SendersEmail'};
    $std->Error(LEVEL=>'2', MESSAGE=>'invite_no_email_f') unless $iB::IN{'RecipientEmail'};
    #+-------------------------------------------------------------------------------------
    $obj->{'OUT'}->{'SENDER_NAME'}    = $std->unHTML($iB::IN{'SenderName'});
    $obj->{'OUT'}->{'MSG_ID'}         = time;
    #+-------------------------------------------------------------------------------------
    $obj->{'OUT'}->{'TO_EMAIL'}       = $iB::IN{'RecipientEmail'};
    my $check = $std->CheckEmail($obj->{'OUT'}->{'TO_EMAIL'});
    $std->Error(LEVEL=>'2', MESSAGE=>'invalid_email') unless $check == 1;
    #+-------------------------------------------------------------------------------------
    $obj->{'OUT'}->{'SENDER_EMAIL'}   = $iB::IN{'SendersEmail'};
    my $check = $std->CheckEmail($obj->{'OUT'}->{'SENDER_EMAIL'});
    $std->Error(LEVEL=>'2', MESSAGE=>'invalid_email') unless $check == 1;
    #+-------------------------------------------------------------------------------------
    my $message = $SEND->parse_template('invite_friend',$obj->{'OUT'});
    $SEND->Send(TO      => $obj->{'OUT'}->{'TO_EMAIL'},
                FROM    => $obj->{'OUT'}->{'SENDER_EMAIL'},
                SUBJECT => $MailFunctions::lang->{'invite_subject'},
                MESSAGE => $message
               );
    $obj->_invite_log() if $INFO->{'LOG_INVITE'};
    $std->Redirect("$MailFunctions::lang->{'invite_redirect'} $obj->{'OUT'}->{'TO_EMAIL'}", '');
}



sub _invite_log ($) {
   my $obj = shift;
   my $data = { MSG_ID      => $obj->{'OUT'}->{'MSG_ID'},
                NAME_GIVEN  => $obj->{'OUT'}->{'SENDER_NAME'},
                MEMBER_NAME => $iB::MEMBER->{'MEMBER_NAME'},
                FROM_EMAIL  => $obj->{'OUT'}->{'SENDER_EMAIL'},
                TO_EMAIL    => $obj->{'OUT'}->{'TO_EMAIL'},
                IP_ADDR     => $ENV{'REMOTE_ADDR'},
                MEMBER_ID   => $iB::MEMBER->{'MEMBER_ID'}
              };
   my $logger = Makelog->new(INDEX=>'invite_log', DATA=>$data);
   $logger->add_log();
}


sub subs ($) {
    my $obj = shift;
    $std->Error(LEVEL=>'1',MESSAGE=>'incorrect_use')  unless defined $std->IsNumber($iB::IN{'f'});
    $std->Error(LEVEL=>'1',MESSAGE=>'incorrect_use')  unless defined $std->IsNumber($iB::IN{'t'});
    $std->Error(LEVEL=>'1',MESSAGE=>'not_registered') unless $iB::MEMBER->{'MEMBER_ID'};
    use iDatabase;
    use iMember;
    my $dbi   = iDatabase->connect($iB::INFO->{'DATABASE_DIR'} . 'Forum' . $iB::IN{'f'} . '/topic-mail-' . $iB::IN{'t'},
                                   $iB::INFO->{'DATABASE_DIR'} . 'Index/topicreplies');

    my $mem = iMember->new();
    my $time = time;
    my $MEMBER = $mem->LoadMember($iB::MEMBER->{'MEMBER_ID'}, 'MemId');

    my $ENTER = {   MEM_ID        => $iB::MEMBER->{'MEMBER_ID'},
                    MEM_NAME      => $MEMBER->{'MEMBER_NAME'},
                    EMAIL_ADDRESS => $MEMBER->{'MEMBER_EMAIL'},
                    FORUM         => $iB::IN{'f'},
                    TOPIC         => $iB::IN{'t'},
                    DATE          => $time,
                    PRUNE         => $MEMBER->{'CANCEL_SUBS'},
                    FULL          => $MEMBER->{'EMAIL_FULL_POST'}
                 };
    my $sth = $dbi->prepare(INSERT=>$ENTER,WHERE=>'at bottom');
    $sth->execute();
    $sth->done();
    $dbi->disconnect($sth);
    my $db   = iDatabase->connect($iB::INFO->{'DATABASE_DIR'} . 'Members/' . $iB::MEMBER->{'MEMBER_ID'} . '-su',
                                  $iB::INFO->{'DATABASE_DIR'} . 'Index/topicreplies');
    my $st = $db->prepare(SELECT=>'*',WHERE=>'line 0');
    $st->execute();
    while (defined(my $Row = $st->get_row() )) {
        if ($Row->{'FORUM'} == $iB::IN{'f'} and $Row->{'TOPIC'} == $iB::IN{'t'}) {
            $std->Error(LEVEL=>'1',MESSAGE=>'already_sub');
            goto END;
        }
    }
    $st = $db->prepare(INSERT=>$ENTER,WHERE=>'at bottom');
    $st->execute();
    $std->Redirect($MailFunctions::lang->{'subs_redirect'}, "?act=ST;f=$iB::IN{'f'};t=$iB::IN{'t'}");
    goto END;

END:    $st->done();
        $db->disconnect($st);
    
}




__END__

1;

   


