package Moderate;
use strict;
#################################################################################
# Ikonboard v3 by Jarvis Entertainment Group, Inc.
#
# No parts of this script can be used outside Ikonboard without prior consent.
#
# More information available from <ib-license@jarvisgroup.net>
# (c)2001 Jarvis Entertainment Group, Inc.
# 
# http://www.ikonboard.com
#
# Please Read the license for more information
#+-----------------------------------------------------------------+
#
# Moderate: Moderation Fucntions.
#
#################################################################################

BEGIN {
    require 'Lib/FUNC.pm';
    require 'iTextparser.pm';
    require 'Searchlog.pm';
    require 'MemberTitles.pm';
}

my $output      = FUNC::Output->new();
my $mem         = FUNC::Member->new();
my $std         = FUNC::STD->new();
my $s_log       = Searchlog->new();
my $txt         = iTextparser->new();
my $rank        = MemberTitles->new();
$Moderate::lang = $std->LoadLanguage('ModerateWords');


sub new {
    my $pkg = shift;
    my $obj = { '.html' => undef, 'PASSED' => 0 };
    bless $obj, $pkg;
    return $obj;
}



sub CloseForm {
    my ($obj,$db) = @_;
    $obj->{'MODE'} = 'CLOSE_TOPIC';
    $obj->CheckAuthorisation();

    $std->Error( DB => $db, LEVEL=>'1',MESSAGE=>'moderate_no_permission') unless $obj->{'PASSED'} == 1;

    $obj->CompileHTML('close');

    $output->print_ikonboard( DB           => $db,
                              STD          => $std,
                              NAV_ONE      => qq[<a href="$iB::INFO->{'BOARD_URL'}/ikonboard.$iB::INFO->{'CGI_EXT'}?s=$iB::SESSION;act=SF;f=$obj->{'FORUM'}->{'FORUM_ID'}" class='nav'>$obj->{'FORUM'}->{'FORUM_NAME'}</a>],
                              NAV_TWO      => qq[<a href="$iB::INFO->{'BOARD_URL'}/ikonboard.$iB::INFO->{'CGI_EXT'}?s=$iB::SESSION;act=ST;f=$obj->{'FORUM'}->{'FORUM_ID'};t=$obj->{'TOPIC'}->{'TOPIC_ID'}" class='nav'>$obj->{'TOPIC'}->{'TOPIC_TITLE'}</a>],
                              OUTPUT       => $obj->{'.html'},
                              JAVASCRIPT   => '1',
                              TITLE        => "iB::" . "Close Topic: $obj->{'TOPIC'}->{'TOPIC_TITLE'}"
                            );

}



sub OpenForm {
    my ($obj,$db) = @_;
    $obj->{'MODE'} = 'OPEN_TOPIC';
    $obj->CheckAuthorisation();

    $std->Error( DB => $db, LEVEL=>'1',MESSAGE=>'moderate_no_permission') unless $obj->{'PASSED'} == 1;

    $obj->CompileHTML('open');

    $output->print_ikonboard( DB           => $db,
                              STD          => $std,
                              NAV_ONE      => qq[<a href="$iB::INFO->{'BOARD_URL'}/ikonboard.$iB::INFO->{'CGI_EXT'}?s=$iB::SESSION;act=SF;f=$obj->{'FORUM'}->{'FORUM_ID'}" class='nav'>$obj->{'FORUM'}->{'FORUM_NAME'}</a>],
                              NAV_TWO      => qq[<a href="$iB::INFO->{'BOARD_URL'}/ikonboard.$iB::INFO->{'CGI_EXT'}?s=$iB::SESSION;act=ST;f=$obj->{'FORUM'}->{'FORUM_ID'};t=$obj->{'TOPIC'}->{'TOPIC_ID'}" class='nav'>$obj->{'TOPIC'}->{'TOPIC_TITLE'}</a>],
                              OUTPUT       => $obj->{'.html'},
                              JAVASCRIPT   => '1',
                              TITLE        => "iB::" . "Open Topic: $obj->{'TOPIC'}->{'TOPIC_TITLE'}"
                            );

}


sub DeleteForm {
    my ($obj,$db) = @_;
    $obj->{'MODE'} = 'DELETE_TOPIC';
    $obj->CheckAuthorisation();
    $std->Error( DB => $db, LEVEL=>'1',MESSAGE=>'moderate_no_permission') unless $obj->{'PASSED'} == 1;
    $obj->CompileHTML('delete');

    $output->print_ikonboard( DB           => $db,
                              STD          => $std,
                              NAV_ONE      => qq[<a href="$iB::INFO->{'BOARD_URL'}/ikonboard.$iB::INFO->{'CGI_EXT'}?s=$iB::SESSION;act=SF;f=$obj->{'FORUM'}->{'FORUM_ID'}" class='nav'>$obj->{'FORUM'}->{'FORUM_NAME'}</a>],
                              NAV_TWO      => qq[<a href="$iB::INFO->{'BOARD_URL'}/ikonboard.$iB::INFO->{'CGI_EXT'}?s=$iB::SESSION;act=ST;f=$obj->{'FORUM'}->{'FORUM_ID'};t=$obj->{'TOPIC'}->{'TOPIC_ID'}" class='nav'>$obj->{'TOPIC'}->{'TOPIC_TITLE'}</a>],
                              OUTPUT       => $obj->{'.html'},
                              JAVASCRIPT   => '1',
                              TITLE        => "iB::" . "Delete Topic: $obj->{'TOPIC'}->{'TOPIC_TITLE'}"
                             );

}

sub EditForm {
    my ($obj,$db) = @_;
    $obj->{'MODE'} = 'EDIT_TOPIC';
    $obj->CheckAuthorisation();
    $std->Error( DB => $db, LEVEL=>'1',MESSAGE=>'moderate_no_permission') unless $obj->{'PASSED'} == 1;
    $obj->CompileHTML('edit');

    $output->print_ikonboard( DB           => $db,
                              STD          => $std,
                              NAV_ONE      => qq[<a href="$iB::INFO->{'BOARD_URL'}/ikonboard.$iB::INFO->{'CGI_EXT'}?s=$iB::SESSION;act=SF;f=$obj->{'FORUM'}->{'FORUM_ID'}" class='nav'>$obj->{'FORUM'}->{'FORUM_NAME'}</a>],
                              NAV_TWO      => qq[<a href="$iB::INFO->{'BOARD_URL'}/ikonboard.$iB::INFO->{'CGI_EXT'}?s=$iB::SESSION;act=ST;f=$obj->{'FORUM'}->{'FORUM_ID'};t=$obj->{'TOPIC'}->{'TOPIC_ID'}" class='nav'>$obj->{'TOPIC'}->{'TOPIC_TITLE'}</a>],
                              OUTPUT       => $obj->{'.html'},
                              JAVASCRIPT   => '1',
                              TITLE        => "iB::" . "Edit Topic: $obj->{'TOPIC'}->{'TOPIC_TITLE'}"
                            );
}

sub MoveForm {
    my ($obj,$db) = @_;
    $obj->{'MODE'} = 'MOVE_TOPIC';
    $obj->CheckAuthorisation();

    $std->Error( DB      => $db,
                 LEVEL   => 1,
                 MESSAGE => 'moderate_no_permission'
               ) unless $obj->{'PASSED'} == 1;

    $std->Error( DB      => $db,
                 LEVEL   => 1,
                 MESSAGE =>'move_already_moved'
               ) if $obj->{'TOPIC'}->{'TOPIC_STATE'} eq 'moved';


    my $html = qq[ <select name='destination' class='forminput'><option value="$iB::INFO->{'BOARD_URL'}/ikonboard.$iB::INFO->{'CGI_EXT'}" selected>
                   <option value="">-----------
                 ];

    return 0 unless (-e $iB::PTH.'/Data/ForumJump.pm');
    
    require 'Data/ForumJump.pm';
    my $Forums = ForumJump->new();

    for (sort { $a <=> $b } keys %{$Forums}) {
        if ($Forums->{$_}[0] eq 'c') {
            if ($Forums->{$_}[3] ne '*') {
                next unless grep { $_ == $iB::MEMBER->{'MEMBER_GROUP'} } (split (/,/, $Forums->{$_}[3]) );
            }
            my $dash = '-' x length($Forums->{$_}[2]);
            $html .= qq[<option value="">&nbsp;\n
                        <option value="">&gt;$Forums->{$_}[2]\n
                        <option value="">&nbsp;&nbsp;$dash\n
                       ];
        } elsif ($Forums->{$_}[0] eq 'f') {
            if ($Forums->{$_}[3] ne '*') {
                next unless grep { $_ == $iB::MEMBER->{'MEMBER_GROUP'} } (split (/,/, $Forums->{$_}[3]) );
            }
            $html .= qq[<option value="$Forums->{$_}[1]">&nbsp;&nbsp;&nbsp;+- $Forums->{$_}[2]\n];
        }
    }

    $html .= qq[</select>\n];

    $obj->CompileHTML('move', $html);

    $output->print_ikonboard( DB           => $db,
                              STD          => $std,
                              NAV          => [
                                                qq!<a href="$iB::INFO->{'BOARD_URL'}/ikonboard.$iB::INFO->{'CGI_EXT'}?s=$iB::SESSION;act=SF;f=$obj->{'FORUM'}->{'FORUM_ID'}" class='nav'>$obj->{'FORUM'}->{'FORUM_NAME'}</a>!,
                                                qq!<a href="$iB::INFO->{'BOARD_URL'}/ikonboard.$iB::INFO->{'CGI_EXT'}?s=$iB::SESSION;act=ST;f=$obj->{'FORUM'}->{'FORUM_ID'};t=$obj->{'TOPIC'}->{'TOPIC_ID'}" class='nav'>$obj->{'TOPIC'}->{'TOPIC_TITLE'}</a>!,
                                              ],
                              OUTPUT       => $obj->{'.html'},
                              JAVASCRIPT   => '1',
                              TITLE        => "iB::" . "Move Topic: $obj->{'TOPIC'}->{'TOPIC_TITLE'}"
                            );
}

#+------------------------------------------------------------------------------------------------------




sub CompileHTML ($$) {
    my ($obj, $type, $other) = @_;

    if ($type eq 'close') {

        $obj->{'.html'}  = $obj->_headers('close');
        $obj->{'.html'} .= ModView::table_top("$Moderate::lang->{'top_close'} $obj->{'FORUM'}->{'FORUM_NAME'} -&gt; $obj->{'TOPIC'}->{'TOPIC_TITLE'}");
        $obj->{'.html'} .= ModView::mod_exp($Moderate::lang->{'close_topic'});
        $obj->{'.html'} .= ModView::text_field();
        $obj->{'.html'} .= ModView::check_boxes();
        $obj->{'.html'} .= ModView::PostIcons();
        $obj->{'.html'} .= ModView::end_form($Moderate::lang->{'submit_close'});

    } elsif ($type eq 'open') {

        $obj->{'.html'}  = $obj->_headers('open');
        $obj->{'.html'} .= ModView::table_top("$Moderate::lang->{'top_open'} $obj->{'FORUM'}->{'FORUM_NAME'} -&gt; $obj->{'TOPIC'}->{'TOPIC_TITLE'}");
        $obj->{'.html'} .= ModView::mod_exp($Moderate::lang->{'open_topic'});
        $obj->{'.html'} .= ModView::text_field();
        $obj->{'.html'} .= ModView::check_boxes();
        $obj->{'.html'} .= ModView::PostIcons();
        $obj->{'.html'} .= ModView::end_form($Moderate::lang->{'submit_open'});

    } elsif ($type eq 'delete') {

        $obj->{'.html'}  = $obj->_headers('delete');
        $obj->{'.html'} .= ModView::table_top("$Moderate::lang->{'top_delete'} $obj->{'FORUM'}->{'FORUM_NAME'} -&gt; $obj->{'TOPIC'}->{'TOPIC_TITLE'}");
        $obj->{'.html'} .= ModView::mod_exp($Moderate::lang->{'delete_topic'});
        $obj->{'.html'} .= ModView::end_form($Moderate::lang->{'submit_delete'});

    } elsif ($type eq 'edit') {

        $obj->{'.html'}  = $obj->_headers('edit');
        $obj->{'.html'} .= ModView::table_top("$Moderate::lang->{'top_edit'} $obj->{'FORUM'}->{'FORUM_NAME'} -&gt; $obj->{'TOPIC'}->{'TOPIC_TITLE'}");
        $obj->{'.html'} .= ModView::mod_exp($Moderate::lang->{'edit_topic'});
        $obj->{'.html'} .= ModView::topictitle_fields($obj->{'TOPIC'}->{'TOPIC_TITLE'}, $obj->{'TOPIC'}->{'TOPIC_DESC'});
        $obj->{'.html'} .= ModView::end_form($Moderate::lang->{'submit_edit'});

    } elsif ($type eq 'move') {

        $obj->{'.html'}  = $obj->_headers('move');
        $obj->{'.html'} .= ModView::table_top("$Moderate::lang->{'top_move'} $obj->{'FORUM'}->{'FORUM_NAME'} -&gt; $obj->{'TOPIC'}->{'TOPIC_TITLE'}");
        $obj->{'.html'} .= ModView::mod_exp($Moderate::lang->{'open_move'});
        $obj->{'.html'} .= ModView::move_form($other, $obj->{'FORUM'}->{'FORUM_NAME'});
        $obj->{'.html'} .= ModView::end_form($Moderate::lang->{'submit_move'});
    }
}

sub _headers ($$) {
    my ($obj, $type) = @_;
    my $return = qq[<form action="$iB::INFO->{'BOARD_URL'}/ikonboard.$iB::INFO->{'CGI_EXT'}" method="post" name='REPLIER'>\n<input type='hidden' name='act' value='Mod'>\n];
    $return   .= qq[<input type='hidden' name='s' value='$iB::SESSION'>\n];
    if ($type eq 'close') {

        $return .= qq[<input type='hidden' name='CODE' value='06'>\n<input type='hidden' name='f' value='$obj->{'FORUM'}->{'FORUM_ID'}'>\n<input type='hidden' name='t' value='$obj->{'TOPIC'}->{'TOPIC_ID'}'>\n];
        
    } elsif ($type eq 'open') {

        $return .= qq[<input type='hidden' name='CODE' value='07'>\n<input type='hidden' name='f' value='$obj->{'FORUM'}->{'FORUM_ID'}'>\n<input type='hidden' name='t' value='$obj->{'TOPIC'}->{'TOPIC_ID'}'>\n];

    } elsif ($type eq 'delete') {

        $return .= qq[<input type='hidden' name='CODE' value='08'>\n<input type='hidden' name='f' value='$obj->{'FORUM'}->{'FORUM_ID'}'>\n<input type='hidden' name='t' value='$obj->{'TOPIC'}->{'TOPIC_ID'}'>\n];

    } elsif ($type eq 'edit') {
   
        $return .= qq[<input type='hidden' name='CODE' value='12'>\n<input type='hidden' name='f' value='$obj->{'FORUM'}->{'FORUM_ID'}'>\n<input type='hidden' name='t' value='$obj->{'TOPIC'}->{'TOPIC_ID'}'>\n];

    } elsif ($type eq 'move') {
   
        $return .= qq[<input type='hidden' name='CODE' value='14'>\n<input type='hidden' name='f' value='$obj->{'FORUM'}->{'FORUM_ID'}'>\n<input type='hidden' name='t' value='$obj->{'TOPIC'}->{'TOPIC_ID'}'>\n];

    } 
}             

#+------------------------------------------------------------------------------------------------------

sub DoMove ($) {
    my ($obj,$db) = @_;

    $obj->move_topic( SOURCE      => $iB::IN{'f'},
                      DESTINATION => $iB::IN{'destination'},
                      TOPIC_ID    => $iB::IN{'t'},
                      LINK        => $iB::IN{'leave'},
                      DB          => $db
                    );
                      

}


sub move_topic {
    my $obj = shift;

    my %IN = ( SOURCE      => "",
               DESTINATION => "",
               TOPIC_ID    => "",
               LINK        => "",
               DB          => "",
               @_,
             );

    my $db = $IN{'DB'};


    #XXX Check for errors....


    $std->Error( DB      => $db,
                 LEVEL   => 1,
                 MESSAGE => 'move_no_forum'
               ) unless defined $IN{'DESTINATION'};

    $std->Error( DB      => $db,
                 LEVEL   => 1,
                 MESSAGE => 'move_no_source'
               ) unless defined $IN{'SOURCE'};


    $std->Error( DB      => $db,
                 LEVEL   => 1,
                 MESSAGE => 'move_same_forum'
               ) if  $IN{'SOURCE'} == $IN{'DESTINATION'};

    $std->Error( DB      => $db,
                 LEVEL   => 1,
                 MESSAGE => 'move_no_topic'
               ) unless defined $IN{'TOPIC_ID'};

    #XXX Grab the old topic

    my $topic = $db->select( TABLE  => 'forum_topics',
                             ID     => $IN{'SOURCE'},
                             KEY    => $IN{'TOPIC_ID'}
                           );

    $std->Error(             DB      => $db,
                             LEVEL   => 1,
                             MESSAGE => 'move_no_topic'
               )             unless defined $topic->{'TOPIC_ID'};


    #XXX Get the destination forum details

    my $forum = $db->select( TABLE  => 'forum_info',
                             KEY    => $IN{'DESTINATION'}
                           );


    #XXX Insert the new topic into the destination forum

    $topic->{'FORUM_ID'} = $IN{'DESTINATION'};
 
    my $nu_id = $db->insert(TABLE  => 'forum_topics',
                            ID     => $IN{'DESTINATION'},
                            VALUES => $topic,
                           );

    #XXX Do we have a new Last Topic & ID in the board index?

    if ($topic->{'TOPIC_LAST_DATE'} > $forum->{'FORUM_LAST_POST'}) {
        $db->update( TABLE  => 'forum_info',
                     KEY    => $IN{'DESTINATION'},
                     VALUES => { FORUM_LAST_POST     => $topic->{'TOPIC_LAST_DATE'},
                                 FORUM_LAST_POSTER   => $topic->{'TOPIC_LAST_POSTER'},
                                 FORUM_LAST_POSTER_N => $topic->{'TOPIC_LASTP_N'},
                                 L_TOPIC_TITLE       => $topic->{'TOPIC_TITLE'},
                                 L_TOPIC_ID          => $nu_id
                               }
                   );
    }

    #XXX Are we keeping a link to the destination forum/new topic id?

    my $bread_crumb = $IN{'LINK'} ? 'moved' : 'dead';

    $db->update(  TABLE  => 'forum_topics',
                  ID     => $IN{'SOURCE'},
                  KEY    => $IN{'TOPIC_ID'},
                  VALUES => { TOPIC_STATE  => $bread_crumb,
                              MOVED_TO     => $IN{'DESTINATION'}.'&'.$nu_id,
                            }
               );

    #XXX Move the posts over

    my $posts = $db->query( TABLE  => 'forum_posts',
                            DBID   => 'f'.$IN{'SOURCE'},
                            ID     => $IN{'TOPIC_ID'},
                          );

    for my $p (@{$posts}) {
        $db->insert( TABLE  => 'forum_posts',
                     DBID   => 'f'.$IN{'DESTINATION'},
                     ID     => $nu_id,
                     VALUES => $p
                   );
    }

    #XXX Done

    $output->redirect_screen(TEXT => "Topic Moved", URL => "act=SF;f=$IN{'SOURCE'}");

}



sub DoEdit ($) {
    my ($obj,$db) = @_;
    $obj->{'MODE'} = 'EDIT_TOPIC';
    $obj->CheckAuthorisation();
    $std->Error( DB => $db, LEVEL=>'1',MESSAGE=>'You do not have permission') unless $obj->{'PASSED'} == 1;
    $std->Error( DB => $db, LEVEL=>'1',MESSAGE=>'no_topic_title') unless $iB::IN{'TopicTitle'};

    $obj->{'TOPIC'}->{'TOPIC_TITLE'} = $iB::IN{'TopicTitle'};
    $obj->{'TOPIC'}->{'TOPIC_DESC'}  = $iB::IN{'TopicDesc'};

    $db->update(  TABLE  => 'forum_topics',
                  KEY    => $obj->{'.topic_id'},
                  ID     => $obj->{'.forum_id'},
                  VALUES => $obj->{'TOPIC'}
                )        || die $db->{'error'};

    $output->redirect_screen(TEXT => "Topic Edited", URL => "act=SF;f=$obj->{'.forum_id'}"); 
}


#+------------------------------------------------------------------------------------------------------
# CLOSE TOPIC

sub CloseTopic {
    my ($obj,$db) = @_;
    $obj->{'MODE'} = 'CLOSE_TOPIC';
    $obj->CheckAuthorisation();
    $std->Error( DB => $db, LEVEL=>'1',MESSAGE=>'moderate_no_permission') unless $obj->{'PASSED'} == 1;
    $obj->{'TOPIC'}->{'TOPIC_STATE'} = 'closed';
    $obj->create_post($db) if $iB::IN{'Post'};
    $db->update(  TABLE  => 'forum_topics',
                  KEY    => $obj->{'.topic_id'},
                  ID     => $obj->{'.forum_id'},
                  VALUES => $obj->{'TOPIC'}
                )        || die $db->{'error'};
    $output->redirect_screen(TEXT => "Topic Closed", URL => "act=ST;f=$obj->{'.forum_id'};t=$obj->{'.topic_id'}"); 
}

#+------------------------------------------------------------------------------------------------------
# OPEN TOPIC


sub OpenTopic {
    my ($obj,$db) = @_;
    $obj->{'MODE'} = 'OPEN_TOPIC';
    $obj->CheckAuthorisation();
    $std->Error( DB => $db, LEVEL=>'1',MESSAGE=>'moderate_no_permission') unless $obj->{'PASSED'} == 1;
    $obj->{'TOPIC'}->{'TOPIC_STATE'} = 'open';
    $obj->create_post($db) if $iB::IN{'Post'};
    $db->update(  TABLE  => 'forum_topics',
                  KEY    => $obj->{'.topic_id'},
                  ID     => $obj->{'.forum_id'},
                  VALUES => $obj->{'TOPIC'}
                )        || die $db->{'error'};
    $output->redirect_screen(TEXT => "Topic Opened", URL => "act=ST;f=$obj->{'.forum_id'};t=$obj->{'.topic_id'}"); 
}

#+------------------------------------------------------------------------------------------------------
# DELETE TOPIC


sub DeleteTopic {
    my ($obj,$db) = @_;
    $obj->{'MODE'} = 'DELETE_TOPIC';
    $obj->CheckAuthorisation();
    $std->Error( DB => $db, LEVEL=>'1',MESSAGE=>'moderate_no_permission') unless $obj->{'PASSED'} == 1;

    $db->delete(  TABLE  => 'forum_topics',
                  ID     => $obj->{'.forum_id'},
                  KEY    => $obj->{'.topic_id'}
               )         || die $db->{'error'};

    $db->delete(  TABLE  => 'forum_posts',
                  DBID   => 'f'.$obj->{'.forum_id'},
                  ID     => $obj->{'.topic_id'},
                  WHERE  => "POST_ID > '0'",
                )        || die $db->{'error'};

    $db->delete(  TABLE  => 'search_log',
                  ID     => $obj->{'.forum_id'},
                  WHERE  => qq[TOPIC_ID == "$obj->{'.topic_id'}"],
               );

    my $stats = $db->select( TABLE   => 'board_statistics',
                             KEY     => 'MAIN',
                           );

    $obj->{'FORUM'}->{'FORUM_TOPICS'}--;
    $obj->{'FORUM'}->{'FORUM_POSTS'} -= $obj->{'TOPIC'}->{'TOPIC_POSTS'};
    $stats->{'TOTAL_REPLIES'}        -= $obj->{'TOPIC'}->{'TOPIC_POSTS'};
    $stats->{'TOTAL_TOPICS'}--;

    $db->update(  TABLE  => 'forum_info',
                  KEY    => $obj->{'.forum_id'},
                  VALUES => $obj->{'FORUM'}
               );

    $db->update(  TABLE  => 'board_statistics',
                  KEY    => 'MAIN',
                  VALUES => $stats
               );

    $output->redirect_screen(TEXT => "Topic Deleted", URL => "act=SF;f=$obj->{'.forum_id'}"); 
}


sub DeletePost {
    my ($obj,$db) = @_;
    $std->Error( DB => $db, LEVEL=>'1',MESSAGE=>'missing_files') unless defined $iB::IN{'t'} and defined $iB::IN{'f'} and defined $iB::IN{'p'};
    $std->Error( DB => $db, LEVEL=>'1',MESSAGE=>'Cannot remove the first post') if $iB::IN{'p'} == 1;
    $obj->{'MODE'} = 'DELETE_POST';
    $obj->CheckAuthorisation();
    $std->Error( DB => $db, LEVEL=>'1',MESSAGE=>'moderate_no_permission') unless $obj->{'PASSED'} == 1;
 
    $db->delete(  TABLE  => 'search_log',
                  ID     => $obj->{'.forum_id'},
                  WHERE  => qq[TOPIC_ID == "$obj->{'.topic_id'}" and POST_ID == "$obj->{'.post_id'}"],
               );

    $db->delete(  TABLE    => 'forum_posts',
                  DBID     => 'f'.$obj->{'.forum_id'},
                  ID       => $obj->{'.topic_id'},
                  KEY      => $obj->{'.post_id'},
               );

    my $stats = $db->select( TABLE   => 'board_statistics',
                             KEY     => 'MAIN',
                           );

    $obj->{'FORUM'}->{'FORUM_POSTS'}--;
    $obj->{'TOPIC'}->{'TOPIC_POSTS'}--;
    $stats->{'TOTAL_REPLIES'}--;

    $db->update(  TABLE  => 'forum_info',
                  KEY    => $obj->{'.forum_id'},
                  VALUES => $obj->{'FORUM'}
               );

    $db->update(  TABLE  => 'forum_topics',
                  KEY    => $obj->{'.topic_id'},
                  ID     => $obj->{'.forum_id'},
                  VALUES => $obj->{'TOPIC'}
                )        || die $db->{'error'};

    $db->update(  TABLE  => 'board_statistics',
                  KEY    => 'MAIN',
                  VALUES => $stats
               );

    $output->redirect_screen(TEXT => "Post Deleted", URL => "act=SF;f=$obj->{'.forum_id'}"); 
}




sub create_post ($) {
    my ($obj,$db) = @_;
    my %POST;
    #+-----------------------------------------------
    $iB::IN{'enablesig'} = $iB::IN{'enablesig'} eq 'yes' ? q|yes| : q|no|;
    $iB::IN{'enableemo'} = $iB::IN{'enableemo'} eq 'yes' ? q|yes| : q|no|;
    #+-----------------------------------------------
    if ($obj->{'MODE'} ne 'MOVE_TOPIC') {
        return unless (length($iB::IN{'Post'}) > 1);
    }
    $iB::IN{'Post'} .= "\nThis topic has been moved here: [url=$iB::INFO->{'BOARD_URL'}/ikonboard.$iB::INFO->{'CGI_EXT'}?act=ST;f=$obj->{'_temp_f'};t=$obj->{'_temp_t'}]here[/url]" if $obj->{'MODE'} eq 'MOVE_TOPICS';
    #+-----------------------------------------------
    $POST{'AUTHOR'}       = $obj->{'MEMBER'}->{'MEMBER_ID'};
    $POST{'ENABLE_SIG'}   = $iB::IN{'enablesig'};
    $POST{'ENABLE_EMO'}   = $iB::IN{'enableemo'};
    $POST{'IP_ADDR'}      = $ENV{'REMOTE_ADDR'};
    $POST{'POST_DATE'}    = time;
    $POST{'POST_ICON'}    = $std->IsNumber($iB::IN{'iconid'}) || 0;
    $POST{'POST'}         = $txt->Convert_for_db( TEXT    => $iB::IN{'Post'},
                                                  SMILIES => $POST{'ENABLE_EMO'},
                                                  IB_CODE => $obj->{'FORUM'}->{'FORUM_IBC'},
                                                  HTML    => $obj->{'FORUM'}->{'FORUM_HTML'}
                                                );
    $POST{'AUTHOR_TYPE'}  = 1;
    $POST{'TOPIC_ID'}     = $obj->{'.topic_id'};
    $POST{'FORUM_ID'}     = $obj->{'.forum_id'};
    $POST{'APPROVED'}     = 1;
    #+-----------------------------------------------
    $obj->{'.post_id'}   = $db->insert( TABLE    => 'forum_posts',
                                        DBID     => 'f'.$obj->{'.forum_id'},
                                        ID       => $obj->{'.topic_id'},
                                        VALUES   => \%POST
                                     ); 
    #+-----------------------------------------------
    ++$obj->{'TOPIC'}->{'TOPIC_POSTS'};
    $obj->{'TOPIC'}->{'TOPIC_LAST_POSTER'} = $obj->{'MEMBER'}->{'MEMBER_ID'};
    $obj->{'TOPIC'}->{'TOPIC_LASTP_N'}     = $obj->{'MEMBER'}->{'MEMBER_NAME'};
    $obj->{'TOPIC'}->{'TOPIC_LAST_DATE'}   = time;
    #+-----------------------------------------------
    $obj->{'MEMBER'}->{'MEMBER_POSTS'}++;
    $obj->{'MEMBER'}->{'LAST_POST'} = $obj->{'.forum_id'}.'-'.$obj->{'.topic_id'}.'-'.time;
    $mem->UpdateMember( DB       => $db,
                        MEMBER   => $obj->{'MEMBER'}
                      );

    $obj->{'FORUM'}->{'L_TOPIC_TITLE'} = $obj->{'TOPIC'}->{'TOPIC_TITLE'};
    $obj->{'FORUM'}->{'L_TOPIC_ID'}    = $obj->{'TOPIC'}->{'TOPIC_ID'};

    my $stats = $db->select( TABLE   => 'board_statistics',
                             KEY     => 'MAIN',
                           );

    ++$obj->{'FORUM'}->{'FORUM_POSTS'};
    ++$stats->{'TOTAL_REPLIES'};

    $stats->{'LAST_POSTER_N'}  = $obj->{'MEMBER'}->{'MEMBER_NAME'};
    $stats->{'LAST_POSTER_ID'} = $obj->{'MEMBER'}->{'MEMBER_ID'};
    $stats->{'LAST_POST_DATE'} = time;

    $obj->{'FORUM'}->{'L_TOPIC_TITLE'}       = substr($obj->{'FORUM'}->{'L_TOPIC_TITLE'},0,22) . '...' if length $obj->{'FORUM'}->{'L_TOPIC_TITLE'} > 22;
    $obj->{'FORUM'}->{'FORUM_LAST_POST'}     = time;
    $obj->{'FORUM'}->{'FORUM_LAST_POSTER_N'} = $obj->{'.g_post'} == 0 ? $std->unHTML($obj->{'MEMBER'}->{'MEMBER_NAME'}) : $iB::IN{'UserName'};
    $obj->{'FORUM'}->{'FORUM_LAST_POSTER'}   = $obj->{'.g_post'} == 0 ? $obj->{'MEMBER'}->{'MEMBER_ID'} : 0;

    $db->update( TABLE  => 'forum_info',
                 KEY    => $obj->{'.forum_id'},
                 VALUES => $obj->{'FORUM'}
               );

    $db->update( TABLE  => 'board_statistics',
                 KEY    => 'MAIN',
                 VALUES => $stats
               );

}





sub UpdateStats {
        my ($obj,$db) = @_;

}





sub PinTopic {
    my ($obj, $db) = @_;
    $obj->{'MODE'} = 'PIN_TOPIC';
    $obj->CheckAuthorisation();
    $std->Error( DB => $db, LEVEL=>'1',MESSAGE=>'moderate_no_permission') unless $obj->{'PASSED'} == 1;
    $db->update(  TABLE  => 'forum_topics',
                  KEY    => $obj->{'.topic_id'},
                  ID     => $obj->{'.forum_id'},
                  VALUES => { PIN_STATE => 1 }
                )        || die $db->{'error'};
    $output->redirect_screen(TEXT => "Topic Pinned", URL => "act=ST;f=$obj->{'.forum_id'};t=$obj->{'.topic_id'}");
}


sub UNPinTopic {
    my ($obj, $db) = @_;
    $obj->{'MODE'} = 'UNPIN_TOPIC';
    $obj->CheckAuthorisation();
    $std->Error( DB => $db, LEVEL=>'1',MESSAGE=>'moderate_no_permission') unless $obj->{'PASSED'} == 1;
    $db->update(  TABLE  => 'forum_topics',
                  KEY    => $obj->{'.topic_id'},
                  ID     => $obj->{'.forum_id'},
                  VALUES => { PIN_STATE => 0 }
                )        || die $db->{'error'};
    $output->redirect_screen(TEXT => "Topic Unpinned", URL => "act=ST;f=$obj->{'.forum_id'};t=$obj->{'.topic_id'}");
}



sub CheckAuthorisation {
    my ($obj,$db) = @_;

    $obj->{'PASSED'} = 1 if $iB::MEMBER_GROUP->{'IS_SUPMOD'};
    $obj->{'PASSED'} = 1 if $obj->{'moderator'}->{ $obj->{'MODE'} };

    $std->Error( DB => $db, LEVEL=>'1',MESSAGE=>'moderate_no_permission') unless $obj->{'PASSED'} == 1;

}







sub Process {
    my ($obj,$db) = @_;
    $std->Error(LEVEL=>'1',MESSAGE=>'Wha.....?') unless (defined $iB::IN{'CODE'}) and
                                                      (defined $iB::IN{'f'});
    require $iB::SKIN->{'DIR'} . '/ModView.pm' or die $!;

    $obj->{'.topic_id'} = $std->IsNumber($iB::IN{'t'}) || 0;
    $obj->{'.forum_id'} = $std->IsNumber($iB::IN{'f'}) || 0;
    $obj->{'.post_id'}  = $std->IsNumber($iB::IN{'p'}) || 0;
    $obj->{'MEMBER'}    = $iB::MEMBER;

    $obj->LoadForum($db);
    $obj->LoadTopic($db) if defined $iB::IN{'t'};
    $obj->SetSession($db);
    my $CodeNo = $std->CheckCodeNo($iB::IN{'CODE'});
    my %Mode = ( '00'     => \&CloseForm,
                 '01'     => \&OpenForm,
                 '02'     => \&MoveForm,
                 '03'     => \&DeleteForm,
                 '04'     => \&DeletePost,
                 '05'     => \&EditForm,

                 '06'     => \&CloseTopic,
                 '07'     => \&OpenTopic,
                 '08'     => \&DeleteTopic,
                 '09'     => \&DeletePost,

                 '10'     => \&ForumModForm,
                 '11'     => \&Announcement,

                 '12'     => \&DoEdit,
                 '13'     => \&Unlucky_for_some,
                 '14'     => \&DoMove,

                 '15'     => \&PinTopic,
                 '16'     => \&UNPinTopic,
                 
               );

  $Mode{$CodeNo} ? $Mode{$CodeNo}->($obj, $db) : ModerateError();
} 
sub Unlucky_for_some { my $luck = 'Usually very bad'; }

#+------------------------------------------------------------------------------------------------------
#+------------------------------------------------------------------------------------------------------
# UNIVERSAL


sub GetPost {
    my ($obj, $db) = @_;
    
    $obj->{'SAVED'} = $db->select( TABLE   => 'forum_posts',
                                   DBID    => 'f'.$obj->{'.forum_id'},
                                   ID      => $obj->{'.topic_id'},
                                   KEY     => $obj->{'.post_id'}
                                 ) || die $db->{'error'};

    $obj->{'SAVED'}->{'POST'}   = $txt->Convert_for_textfield($obj->{'SAVED'}->{'POST'});

}

#+------------------------------------------------------------------------------------------------------



sub LoadForum {
    my ($obj, $db) = @_;
    $obj->{'.forum_id'} ||= $iB::IN{'f'};
    $obj->{'FORUM'} = $db->select( TABLE   => 'forum_info',
                                   KEY     => $obj->{'.forum_id'},
                                 ) || die $db->{'error'};

    if ($obj->{'FORUM'}->{'FORUM_PROTECT'} eq 'group') {
        my @group_ids = split ",",$obj->{'FORUM'}->{'FORUM_PROTECT_T'};
        $obj->{'FORUM'}->{'FORUM_PROTECT_T'} = \@group_ids;
    }

}

#+------------------------------------------------------------------------------------------------------

sub LoadTopic {
    my ($obj, $db) = @_;

    $obj->{'TOPIC'} = $db->select( TABLE  => 'forum_topics',
                                   ID     => $obj->{'.forum_id'},
                                   KEY    => $obj->{'.topic_id'}
                                 ) || die $db->{'error'};

}

#+------------------------------------------------------------------------------------------------------

sub SetSession {
    my ($obj, $db) = @_;

    $std->Error( DB      => $db,
                 LEVEL   => 1,
                 MESSAGE =>'moderate_no_permission'
               ) unless $iB::MEMBER->{'MEMBER_ID'};

    unless( !$iB::MEMBER->{'ID'} or $iB::MEMBER_GROUP->{'IS_SUPMOD'} ) {

        $obj->{'moderator'} = $db->query( TABLE      => 'forum_moderators',
                                          MATCH      => 'ONE',
                                          WHERE      => qq!FORUM_ID == "$obj->{'.forum_id'}" and MEMBER_ID eq "$iB::MEMBER->{'MEMBER_ID'}"!
                                        );
        $obj->{'moderator'} ||= { }; # unless  $obj->{'moderator'}->{'MODERATOR_ID'};
    }


}

#+------------------------------------------------------------------------------------------------------

sub ModerateError  { $std->Error(LEVEL=>'1',MESSAGE=>'No Action has been specified') }


1;


__END__
