package Search;
use strict;
#################################################################################
# Ikonboard v3 by Jarvis Entertainment Group, Inc.
#
# No parts of this script can be used outside Ikonboard without prior consent.
#
# More information available from <ib-license@jarvisgroup.net>
# (c)2001 Jarvis Entertainment Group, Inc.
# 
# http://www.ikonboard.com
#
# Please Read the license for more information
#+-----------------------------------------------------------------+
#
# Register: Registration Fucntions.
#
#################################################################################

BEGIN {
   require 'Lib/FUNC.pm';
}

my $output    = FUNC::Output->new();
my $std       = FUNC::STD->new();
$Search::lang = $std->LoadLanguage('SearchWords');
#+------------------------------------------------------------------------------------------------------

sub new {
  my $pkg = shift;
  my $obj = {};
  bless $obj, $pkg;
  return $obj;
}

#+------------------------------------------------------------------------------------------------------


sub SearchForm {
    my ($obj, $db) = @_;

    my $select_html = qq[\t<select name='forums' multiple size='10'  class='textinput' style='width:100%;' onChange='addForum()'>\n
                           <option value='all'>&gt;&gt;All open forums
                           <option value='-'>--------------------\n];

    $obj->{'TOTAL_CATS'}   = $db->query(TABLE     => 'categories',
                                        SORT_KEY  => 'CAT_POS',
                                        SORT_BY   => 'A-Z',
                                        WHERE     => 'CAT_STATE ne "off"',
                                        MATCH     => 'ALL',
                                      ) || die $db->{'error'};

    $obj->{'TOTAL_FORUMS'} = $db->query(TABLE     => 'forum_info',
                                        SORT_KEY  => 'FORUM_POSITION',
                                        SORT_BY   => 'A-Z',
                                        MATCH     => 'ALL'
                                      ) || die $db->{'error'};



    for my $this_cat (@{ $obj->{'TOTAL_CATS'} }) {

        my @these_cat_forums = grep { $_->{'CATEGORY'} == $this_cat->{'CAT_ID'} } @{ $obj->{'TOTAL_FORUMS'} };

        $select_html .= qq[\t\t<option value='-'>&gt;&gt;$this_cat->{'CAT_NAME'}];


        for my $this_forum (@these_cat_forums) {
            
            if ($this_forum->{'FORUM_PROTECT'}) {
                next unless $iB::MEMBER->{'MEMBER_ID'};
                next unless defined $iB::MEMBER->{'MEMBER_GROUP'};
                $this_forum->{'N_LINK'} = qq[$Boards::lang->{'f_protected'}];
                if ($this_forum->{'FORUM_PROTECT'} eq 'user') {
                    next unless grep { $this_forum->{'FORUM_ID'} } @{$iB::MEMBER->{'FORUMS_ALLOWED'}};
                }
                elsif ($this_forum->{'FORUM_PROTECT'} eq 'group') {
                    next unless grep { $_ eq $iB::MEMBER->{'MEMBER_GROUP'} } @{$this_forum->{'FORUM_PROTECT_T'}};
                }
                elsif ($obj->{'FORUM'}->{'FORUM_PROTECT'} eq 'pass') {
                    next unless (exists $iB::COOKIES->{ 'iBForum' . $obj->{'FORUM'}->{'FORUM_ID'} });
                    next unless $iB::COOKIES->{ 'iBForum' . $obj->{'FORUM'}->{'FORUM_ID'} } eq $obj->{'FORUM'}->{'FORUM_PROTECT_T'};
                }
            }
            
            $select_html .= (defined $iB::IN{'f'} and $iB::IN{'f'} == $this_forum->{'FORUM_ID'})
                            ? (qq[\t\t\t<option value='$this_forum->{'FORUM_ID'}' selected>&nbsp;-$this_forum->{'FORUM_NAME'}\n])
                            : (qq[\t\t\t<option value='$this_forum->{'FORUM_ID'}'>&nbsp;-$this_forum->{'FORUM_NAME'}\n]);

        }
    }
    
    $select_html .= "\t</select>";

 
    $output->print_ikonboard( DB           => $db,
                              STD          => $std,
                              NAV_ONE      => "Search",
                              OUTPUT       => &SearchView::Form($select_html),
                              JAVASCRIPT   => '1',
                              TITLE        => "iB::" . "Search Form"
                            );
}


sub get_new {
    my ($obj, $db) = @_;

    my $forums = $db->query( TABLE     => 'forum_info',
                             SORT_KEY  => 'FORUM_POSITION',
                             SORT_BY   => 'A-Z',
                             MATCH     => 'ALL',
                             COLUMNS   => ['FORUM_ID', 'FORUM_PROTECT', 'FORUM_VIEW_THREADS'],
                           ) || die $db->{'error'};

    my @search;

    for my $f (@{$forums}) {

        if ($f->{'FORUM_PROTECT'}) {
            next unless $iB::COOKIES->{ $iB::INFO->{'COOKIE_ID'}.'iBForum' . $f->{'FORUM_ID'} } eq $f->{'FORUM_PROTECT'};
        }
        
        if ($f->{'FORUM_VIEW_THREADS'} ne '*') {
            next unless grep { $_ == $iB::MEMBER->{'MEMBER_GROUP'} } (split /,/,$f->{'FORUM_VIEW_THREADS'});
        }

        my $results = $db->query( TABLE   => 'forum_topics',
                                  ID      => $f->{'FORUM_ID'},
                                  WHERE   => qq|TOPIC_LAST_DATE > "$iB::MEMBER->{'LAST_LOG_IN'}"|,
                                  COLUMNS => ['TOPIC_ID'],
                                );

        for my $t (@{$results}) {
            push @search, { FORUM_ID => $f->{'FORUM_ID'}, TOPIC_ID => $t->{'TOPIC_ID'} };
        }
    }

    unless (scalar (@search) > 0) {
        $std->Error( DB => $db, STD => $std, MESSAGE => 'no_results');
    }

    my $where;

    for my $s (@search) {
        $where .= $s->{'FORUM_ID'}.'+'.$s->{'TOPIC_ID'}.'+'.''.'|&|';
    }
    my $search_key = $obj->my_gen_id();

    $db->insert(  TABLE  => 'search_results',
                  VALUES => { ID       => $search_key,
                              DATE     => time,
                              WHERE    => $where,
                              KEYWORDS => 'New Posts',
                              ORDER    => 'Z-A',
                              PRUNE    => 1
                            }
               );

    $output->redirect_screen(  TEXT => "Search Completed, taking you to your results", URL => "act=Search&CODE=02&SID=$search_key");    

}





sub do_search {
    my ($obj, $db) = @_;

    my @forums;

    my ($query, $found, $where_string);

    $std->Error( LEVEL => 1, MESSAGE => 'no_search_words') unless $iB::IN{'keywords'};
  
    if ($iB::CGI->param('forums') eq 'all') {

        my $forums = $db->query( TABLE     => 'forum_info',
                                 SORT_KEY  => 'FORUM_POSITION',
                                 SORT_BY   => 'A-Z',
                                 MATCH     => 'ALL',
                                 COLUMNS   => ['FORUM_ID', 'FORUM_PROTECT', 'FORUM_PROTECT_T'],
                               ) || die $db->{'error'};

        for my $i (@{$forums}) {

            if ($i->{'FORUM_PROTECT'} eq 'user') {
                next unless grep { $i->{'FORUM_ID'} } (split /,/,$iB::MEMBER->{'FORUMS_ALLOWED'});
            }
            elsif ($i->{'FORUM_PROTECT'} eq 'group') {
                next unless grep { $_ eq $iB::MEMBER->{'MEMBER_GROUP'} } (split /,/,$i->{'FORUM_PROTECT_T'}); 
            }
            elsif ($i->{'FORUM_PROTECT'} eq 'pass') {
                next unless $iB::COOKIES->{ $iB::INFO->{'COOKIE_ID'}.'iBForum' . $i->{'FORUM_ID'} } eq $i->{'FORUM_PROTECT_T'};
            }
        
            push @forums, $i->{'FORUM_ID'};
        }
    }
    else {

        @forums = grep { $_ =~ /^\d/ } $iB::CGI->param('forums');

    }

    $std->Error( DB => $db, LEVEL => 1, MESSAGE => 'no_search_forum') unless @forums > 0;

    $query = "LOG_ID ne 'x'";

    if ($iB::IN{'keywords'} =~ /\s{1}(and|AND|or|OR)\s{1}/) {
        for (split /\s{1}(and|AND|or|OR)\s{1}/, $iB::IN{'keywords'}) {
            my $boolean = $1;
            my $word = $_;
            if ($iB::IN{'search_in'} eq 'Post' or $iB::IN{'search_in'} eq 'all' or $iB::IN{'type'} eq 'name') {
               $query .= $iB::IN{'type'} eq 'post' ? " $boolean POST =~ /\\b$word\\b/i" : " $boolean MEMBER_NAME =~ /$word/i";
            }
            elsif ($iB::IN{'search_in'} eq 'titles') {
                $query .= " $boolean TOPIC_TITLE =~ /\\b$word\\b/i";
            }
        }
    } else {
        $query .= $iB::IN{'type'} eq 'post' ? " and POST =~ /\\b$iB::IN{'keywords'}\\b/i" : " and MEMBER_NAME =~ /$iB::IN{'keywords'}/i";
    }

    if ($iB::IN{'prune'} > 0) {
        my $gt_lt = $iB::IN{'prune_type'} eq 'older' ? "<" : ">";
        my $time = time - ($iB::IN{'prune'} * 86400);
        $query .= " and DATE $gt_lt \"$time\"";
    }

    my $results = {};

    for my $this_forum (@forums) {
        my $found = $db->query(  TABLE    => 'search_log',
                                 ID       => $this_forum,
                                 WHERE    => $query,
                                 SORT_KEY => 'TOPIC_TITLE'
                              );
        $results->{$this_forum} = $found;
    }

    for my $key (keys %{$results}) {
        for my $entry (@{ $results->{$key} }) {
            $where_string .= $entry->{'FORUM_ID'}.'+'.$entry->{'TOPIC_ID'}.'+'.$entry->{'POST_ID'}.'|&|';
        }
    }

    my $search_key = $obj->my_gen_id();

    $db->insert(  TABLE  => 'search_results',
                  VALUES => { ID       => $search_key,
                              DATE     => time,
                              WHERE    => $where_string,
                              KEYWORDS => $iB::IN{'keywords'},
                              ORDER    => $iB::IN{'sort_order'},
                              PRUNE    => $iB::IN{'prune'}
                            }
               );

    $output->redirect_screen(  TEXT => "Search Completed, taking you to your results", URL => "act=Search&CODE=02&SID=$search_key");    

}


sub show_results {
    my ($obj, $db) = @_;

    my $forums = $db->query( TABLE     => 'forum_info',
                             SORT_KEY  => 'FORUM_POSITION',
                             SORT_BY   => 'A-Z',
                             MATCH     => 'ALL',
                             COLUMNS   => ['FORUM_ID', 'FORUM_PROTECT', 'FORUM_VIEW_THREADS', 'FORUM_NAME'],
                           ) || die $db->{'error'};


    my $print = SearchView::start();

    my $topic_hash = {};
    my $forum_hash = {};

    my $results = $db->select(  TABLE  => 'search_results',
                                KEY    => $iB::IN{'SID'}
                             );

    for my $f (@{$forums}) {

        if ($f->{'FORUM_PROTECT'}) {
            next unless $iB::COOKIES->{ $iB::INFO->{'COOKIE_ID'}.'iBForum' . $f->{'FORUM_ID'} } eq $f->{'FORUM_PROTECT'};
        }
        
        if ($f->{'FORUM_VIEW_THREADS'} ne '*') {
            next unless grep { $_ == $iB::MEMBER->{'MEMBER_GROUP'} } (split /,/,$f->{'FORUM_VIEW_THREADS'});
        }

        $forum_hash->{ $f->{'FORUM_ID'} } = { 'FORUM_ID'   => $f->{'FORUM_ID'},
                                              'FORUM_NAME' => $f->{'FORUM_NAME'},
                                            };
    }

    
    for my $result (split /\|&\|/, $results->{'WHERE'}) {

        my ($forum_id, $topic_id, $post_id) = split /\+/, $result;
        my $add = $forum_id."_".$topic_id;
        unless (exists $topic_hash->{$add}) {
            my $entry = $db->select(  TABLE  => 'forum_topics',
                                      ID     => $forum_id,
                                      KEY    => $topic_id
                                    );
            $entry->{'KEY_WORD'}   = $results->{'KEYWORDS'};
            $entry->{'FORUM_ID'}   = $forum_hash->{$forum_id}->{'FORUM_ID'};
            $entry->{'FORUM_NAME'} = $forum_hash->{$forum_id}->{'FORUM_NAME'};
            $print .= $obj->_do_row( DB => $db, DATA => $entry, PIN => 0 ) if $entry->{'TOPIC_TITLE'} ne '';
            $topic_hash->{$add} = 1;
        }
    }

    $print .= SearchView::end();

    $output->print_ikonboard( DB           => $db,
                              STD          => $std,
                              NAV_ONE      => "Your Search Results",
                              OUTPUT       => $print,
                              JAVASCRIPT   => '1',
                              TITLE        => "iB::" . "Search Results"
                            );
    
        
}

sub _do_row {
    my $obj = shift;
    my $IN  = { DB => "", DATA => "", PIN => "", @_,};
    my $db = $IN->{'DB'};

    $obj->{'.cur_topic'} = $IN->{'DATA'};

    $obj->{'.cur_topic'}->{'LAST_POSTER'}      = ($obj->{'.cur_topic'}->{'TOPIC_LAST_POSTER'} != 0)   ? qq[<b><a href='$iB::INFO->{'BOARD_URL'}/ikonboard.$iB::INFO->{'CGI_EXT'}?s=$iB::SESSION;act=Profile;CODE=03;MID=$obj->{'.cur_topic'}->{'TOPIC_LAST_POSTER'}' class='misc'>$obj->{'.cur_topic'}->{'TOPIC_LASTP_N'}</a></b>]
                                                                                                      : qq[<font class='misc'>-$obj->{'.cur_topic'}->{'TOPIC_LASTP_N'}-</font>];

    $obj->{'.cur_topic'}->{'FOLDER_ICON'}      = $obj->folder_icon();

    $obj->{'.cur_topic'}->{'TOPIC_LAST_DATE'}  = $obj->get_last_date();

    $obj->{'.cur_topic'}->{'TOPIC_ICON'}       = $obj->{'.cur_topic'}->{'TOPIC_ICON'} ? $iB::INFO->{'IMAGES_URL'} . '/PostIcons/icon' . $obj->{'.cur_topic'}->{'TOPIC_ICON'} . '.gif'
                                                                                      : $iB::INFO->{'IMAGES_URL'} . '/PostIcons/icon0.gif';

    $obj->{'.cur_topic'}->{'TOPIC_ICON'}       = qq[$iB::INFO->{'IMAGES_URL'}/images/f_pin.gif] if $IN->{'PIN'};

    $obj->{'.cur_topic'}->{'TOPIC_START_DATE'} = $std->GetDate($obj->{'.cur_topic'}->{'TOPIC_START_DATE'});

    $obj->{'.cur_topic'}->{'.css_style'}       = $IN->{'PIN'} ? 'pinned' : 'linkthru';


    my $Pages = ($obj->{'.cur_topic'}->{'TOPIC_POSTS'} + 1) / $iB::INFO->{'DISPLAY_MAX_POSTS'};
    my ($Int, $Dec) = split /\./,$Pages;
    $Dec > 0 ? ($Pages = $Int + 1) : ($Pages = $Int);
    $Pages = 1 if $Pages < 1;
    if ($Pages > 1) {
        $obj->{'.cur_topic'}->{'PAGES'} = qq[<font class='misc'>(Pages ];
        my $i = 0;
        for(0 .. $Pages-1) {
            my $RealNo = $i * $iB::INFO->{'DISPLAY_MAX_POSTS'}; my $PageNo = $i + 1;
            if ($PageNo == 4) { $obj->{'.cur_topic'}->{'PAGES'} .= qq[<a href='$iB::INFO->{'BOARD_URL'}/ikonboard.$iB::INFO->{'CGI_EXT'}?s=$iB::SESSION;act=ST;f=$iB::IN{'f'};t=$obj->{'.cur_topic'}->{'TOPIC_ID'};st=] . ($Pages - 1) * $iB::INFO->{'DISPLAY_MAX_POSTS'} . qq[' class='misc'>..$Pages </a>]; last; }
            $obj->{'.cur_topic'}->{'PAGES'} .= qq[<a href='$iB::INFO->{'BOARD_URL'}/ikonboard.$iB::INFO->{'CGI_EXT'}?s=$iB::SESSION;act=ST;f=$iB::IN{'f'};t=$obj->{'.cur_topic'}->{'TOPIC_ID'};st=$RealNo' class='misc'>$PageNo </a>];
            ++$i;
        }
        $obj->{'.cur_topic'}->{'PAGES'} .= qq[)</font>];
    }
    return SearchView::row( $obj->{'.cur_topic'} );
}

sub folder_icon ($) {
    my $obj = shift;
    return qq[$iB::INFO->{'IMAGES_URL'}/images/f_norm.gif]       unless $iB::MEMBER->{'MEMBER_ID'};
    return qq[$iB::INFO->{'IMAGES_URL'}/images/f_locked.gif]     if     $obj->{'.cur_topic'}->{'TOPIC_STATE'} eq 'closed';
    return qq[$iB::INFO->{'IMAGES_URL'}/images/f_poll.gif]       if     (($obj->{'.cur_topic'}->{'POLL_STATE'}) and ($iB::MEMBER->{'LAST_LOG_IN'} && ($obj->{'.cur_topic'}->{'LAST_VOTE'} > $iB::MEMBER->{'LAST_LOG_IN'})));
   #return qq[$iB::INFO->{'IMAGES_URL'}/images/f_poll_no_new.gif]if     $obj->{'.cur_topic'}->{'POLL_STATE'};
    return qq[$iB::INFO->{'IMAGES_URL'}/images/f_moved.gif]      if     $obj->{'.cur_topic'}->{'TOPIC_STATE'} eq 'moved';
    return qq[$iB::INFO->{'IMAGES_URL'}/images/f_hot_no_new.gif] if     (($obj->{'.cur_topic'}->{'TOPIC_POSTS'} + 1 >= $iB::INFO->{'HOT_TOPIC'}) and ($iB::MEMBER->{'LAST_LOG_IN'} && ($obj->{'.cur_topic'}->{'TOPIC_LAST_DATE'} < $iB::MEMBER->{'LAST_LOG_IN'})));
    return qq[$iB::INFO->{'IMAGES_URL'}/images/f_hot.gif]        if     $obj->{'.cur_topic'}->{'TOPIC_POSTS'} + 1 >= $iB::INFO->{'HOT_TOPIC'};
    return qq[$iB::INFO->{'IMAGES_URL'}/images/f_new.gif]        if     $iB::MEMBER->{'LAST_LOG_IN'} && ($obj->{'.cur_topic'}->{'TOPIC_LAST_DATE'} > $iB::MEMBER->{'LAST_LOG_IN'});
    return qq[$iB::INFO->{'IMAGES_URL'}/images/f_norm.gif];
}
        
sub get_last_date ($) {
    my $obj = shift;
    return $obj->{'.cur_topic'}->{'LAST_VOTE'} > $obj->{'.cur_topic'}->{'TOPIC_LAST_DATE'} ? $obj->is_vote() : $obj->is_post();
}

sub is_vote ($) {
    my $obj = shift;
    #$obj->{'.cur_topic'}->{'LAST_ICON'} = 'last_vote.gif';
    return $std->GetDate($obj->{'.cur_topic'}->{'LAST_VOTE'});
}

sub is_post ($) {
    my $obj = shift;
    #$obj->{'.cur_topic'}->{'LAST_ICON'} = 'last_post.gif';
    return $std->GetDate($obj->{'.cur_topic'}->{'TOPIC_LAST_DATE'});
}




sub Process {
    my ($obj,$db) = @_;
    $std->Error(LEVEL=>'1',MESSAGE=>'poss_hack_attempt') unless (defined $iB::IN{'CODE'});

    require $iB::SKIN->{'DIR'} . '/SearchView.pm' or die $!;

    $obj->{'.forum_id'} = $std->IsNumber($iB::IN{'f'});

    my $CodeNo = $std->CheckCodeNo($iB::IN{'CODE'});
    my %Mode = ( '00'     => \&SearchForm,
                 '01'     => \&do_search,
                 '02'     => \&show_results,

                 '03'     => \&get_new,
               );

  $Mode{$CodeNo} ? $Mode{$CodeNo}->($obj, $db) : SearchError();
} 




sub my_gen_id {
    my $obj = shift;
    srand($$|time);
    my $session = int(rand(60000000));
    return unpack("H*", pack("Nnn", time, $$, $session));

}
#+------------------------------------------------------------------------------------------------------

1;

__END__
