package UserCP::Menu;
use strict;
#+------------------------------------------------------------------------------------------------------
#| Ikonboard by Matthew Mecham [ v3.0 ]
#|
#| No parts of this script can be used outside Ikonboard without prior consent.
#| You must keep this header intact and all copyright links visable.
#| (c)2001 Ikonboard.com <http://www.ikonboard.com>
#|
#| Please Read the licence for more information.
#+------------------------------------------------------------------------------------------------------
BEGIN {
    require 'Lib/FUNC.pm';
    require 'iTextparser.pm';
}
my $std       = FUNC::STD->new();
my $mem       = FUNC::Member->new();
my $output    = FUNC::Output->new();
my $txt       = iTextparser->new();
$UserCP::lang = $std->LoadLanguage('UserCPWords');


sub new {
    my $pkg = shift;
    my $obj = { '.html' => undef };
    bless $obj, $pkg;
    return $obj;
}

#+------------------------------------------------------------------------------------------------------

sub Splash ($) {
    my ($obj, $db) = @_;
    $iB::MEMBER->{'DATE_REGISTERED'} = $std->get_date(  TIME   => $iB::MEMBER->{'MEMBER_JOINED'},
                                                        METHOD => 'LONG',
                                                     );

    $iB::MEMBER->{'DAILY_AVERAGE'}  = $iB::MEMBER->{'MEMBER_POSTS'} > 0
                                    ? $obj->get_daily()
                                    : $UserCP::lang->{'no_posts'};

    $obj->{'.html'} .= MenuView::splash($iB::MEMBER);

    $obj->{'.html'} .= MenuView::CP_end();
}


sub get_daily ($) {
   my $obj = shift;
   return unless $iB::MEMBER->{'MEMBER_POSTS'};
   my $diff = time - $iB::MEMBER->{'MEMBER_JOINED'};
   my $days = ($diff / 3600) / 24;
   $days = 1 if $days < 1;
   return sprintf '%.2f', $iB::MEMBER->{'MEMBER_POSTS'} / $days;
}
   


sub Personal ($) {
    my ($obj, $db) = @_;
    $obj->_personal_splash($db) unless $std->IsNumber($iB::IN{'MODE'});
    $obj->_personal_avatar($db) if $std->IsNumber($iB::IN{'MODE'}) == 1;
    $obj->_personal_panel($db)  if $std->IsNumber($iB::IN{'MODE'}) == 2;
    $obj->{'.html'} .= MenuView::CP_end();
}

sub _personal_splash ($) {
    my $obj = shift;
    $obj->{'.html'} .= MenuView::personal_splash();
    $obj->{'.html'} .= MenuView::personal_splash_av() if $iB::INFO->{'AVATARS'};
}


sub _personal_avatar ($) {
    my ($obj, $db) = @_;
    $std->Error(DB => $db, STD => $std, LEVEL=>1,MESSAGE=>'no_avatar') unless $iB::INFO->{'AVATARS'};
    #+-------------------------------------------------------------------------------
    opendir AVATARS, $iB::INFO->{'HTML_DIR'} . 'avatars' or die $!;
    my @avatars = map   {         $_->[0]        }
                  sort  {   $a->[0] cmp $b->[0]  }
                  map   {       [split /\./]     }
                  grep  {          !/^\./        } readdir AVATARS;
    closedir AVATARS;
    #+-------------------------------------------------------------------------------
    my $current_avatar;
    $current_avatar = (split /\./,$iB::MEMBER->{'MEMBER_AVATAR'})[0] unless $current_avatar =~ m#\Ahttp\://#i;
    $current_avatar = 'noavatar' unless $current_avatar;
    $current_avatar = 'noavatar' if $iB::MEMBER->{'MEMBER_AVATAR'} =~ m#\Ahttp\://#i;

    my $avatars = qq!<select name="useravatar" size='10' onChange="showimage('$iB::INFO->{'AVATARS_URL'}/')" class='forminput'>!;
    for (@avatars) {
        $avatars .= $_ eq $current_avatar  ? qq!<option value='$_' selected>$_</option>\n!
                                           : qq!<option value='$_'>$_</option>\n!;
    }
    $avatars .= qq!</select>\n!;
    #+-------------------------------------------------------------------------------
    my $show_avatar    = qq!<img src="$iB::INFO->{'AVATARS_URL'}/$current_avatar.gif" name='useravatars' width='$iB::INFO->{'AV_WIDTH'}' height='$iB::INFO->{'AV_HEIGHT'}' border='0' hspace='15'>\n!;
    $obj->{'.html'} .= MenuView::personal_avatar($iB::MEMBER,$avatars, $show_avatar);
    #+-------------------------------------------------------------------------------
    my $url_avatar;
    $url_avatar = $iB::MEMBER->{'MEMBER_AVATAR'} if $iB::MEMBER->{'MEMBER_AVATAR'} =~ m#\Ahttp\://#i;
    $url_avatar = 'http://' unless $url_avatar;
    my $allowed_ext = '.' . join ' .', (split /\|/,$iB::INFO->{'AV_EXT'});
    ($iB::MEMBER->{'AVATAR_WIDTH'}, $iB::MEMBER->{'AVATAR_HEIGHT'}) = split("x", $iB::MEMBER->{'AVATAR_DIMS'});
    $obj->{'.html'} .= MenuView::personal_avatar_URL($iB::MEMBER,$url_avatar, $allowed_ext) if $iB::INFO->{'AV_ALLOW_URL'};
    #+-------------------------------------------------------------------------------
    $obj->{'.html'} .= MenuView::CP_end();
    
}

sub _personal_panel ($) {
    my $obj = shift;
    $iB::MEMBER->{'SIGNATURE'} = $txt->Convert_for_textfield($iB::MEMBER->{'SIGNATURE'});
    $iB::MEMBER->{'LOCATION'}  = $txt->Convert_for_textfield($iB::MEMBER->{'LOCATION'});
    $iB::MEMBER->{'INTERESTS'} = $txt->Convert_for_textfield($iB::MEMBER->{'INTERESTS'});   
    $obj->{'.html'} .= MenuView::personal_panel($iB::MEMBER);
}



sub Email ($) {
    my ($obj, $db) = @_;
    for (qw[HIDE_EMAIL ALLOW_ADMIN_EMAIL EMAIL_FULL_POST PM_REMINDER]) { $iB::MEMBER->{$_} = 'checked' if $iB::MEMBER->{$_} }
    $iB::MEMBER->{'CANCEL_SUBS'} = '30' unless $iB::MEMBER->{'CANCEL_SUBS'};
    $obj->{'.html'} .= MenuView::email($iB::MEMBER);
    $obj->{'.html'} .= MenuView::CP_end();
}

sub Subs ($) {
    my ($obj, $db) = @_;
    $obj->{'.html'} .= MenuView::subs_header();

   
    $obj->{'.html'} .= MenuView::subs_end();
    $obj->{'.html'} .= MenuView::CP_end();
}


sub Cancelsub {
    my ($obj, $db) = @_;
    $std->Error(LEVEL=>'2', MESSAGE=>'incorrect_use') unless defined $std->IsNumber($iB::IN{'SUID'});
    $std->Error(LEVEL=>'2', MESSAGE=>'incorrect_use') unless defined $std->IsNumber($iB::IN{'t'});
    $std->Error(LEVEL=>'2', MESSAGE=>'incorrect_use') unless defined $std->IsNumber($iB::IN{'f'});

    my $dbu = iDatabase->connect($iB::INFO->{'DATABASE_DIR'} . 'Members/' . $iB::MEMBER->{'MEMBER_ID'} . '-su',
                                 $iB::INFO->{'DATABASE_DIR'} . 'Index/topicreplies');
    my $st = $dbu->prepare(REMOVE=>'*',WHERE=>"DATE = '$iB::IN{SUID}'");
    $st->execute();
    $st->done;
    $dbu->disconnect($st);

    my $dbi = iDatabase->connect($iB::INFO->{'DATABASE_DIR'} . 'Forum' . $iB::IN{'f'} . '/topic-mail-' . $iB::IN{'t'},
                                 $iB::INFO->{'DATABASE_DIR'} . 'Index/topicreplies');
    my $sth = $dbi->prepare(REMOVE=>'*',WHERE=>"MEM_ID = '$obj->{R_MEMBER}->{MEMBER_ID}'");
    $sth->execute();
    $sth->done;
    $dbi->disconnect($sth);
    $std->Redirect($UserCP::lang->{'subs_deleted'}, "?act=UserCP;CODE=03");

}





sub Settings ($) {
    my ($obj, $db) = @_;

    my $time_select = qq|<select name="u_timezone" class='forminput'><option value="-23">- 23<option value="-22">- 22<option value="-21">- 21<option value="-20">- 20<option value="-19">- 19<option value="-18">- 18<option value="-17">- 17<option value="-16">- 16<option value="-15">- 15<option value="-14">- 14<option value="-13">- 13<option value="-12">- 12<option value="-11">- 11<option value="-10">- 10<option value="-9">- 9<option value="-8">- 8<option value="-7">- 7<option value="-6">- 6<option value="-5">- 5<option value="-4">- 4<option value="-3">- 3<option value="-2">- 2<option value="-1">- 1<option value="0">0<option value="1">+ 1<option value="2">+ 2<option value="3">+ 3<option value="4">+ 4<option value="5">+ 5<option value="6">+ 6<option value="7">+ 7<option value="8">+ 8<option value="9">+ 9<option value="10">+ 10<option value="11">+ 11<option value="12">+ 12<option value="13">+ 13<option value="14">+ 14<option value="15">+ 15<option value="16">+ 16<option value="17">+ 17<option value="18">+ 18<option value="19">+ 19<option value="20">+ 20<option value="21">+ 21<option value="22">+ 22<option value="23">+ 23</select>|;
    $time_select =~ s!value="$iB::MEMBER->{'TIME_ADJUST'}">!value="$iB::MEMBER->{'TIME_ADJUST'}" selected>!;

    my $time        = $std->get_date( TIME => time, METHOD => 'LONG');
    my $lang_select = "<select name='u_language' class='forminput'>";

    my @languages = split( /\|\&\|/, $iB::INFO->{'LANGUAGES'} );

    for my $l (@languages) {
        @_ = split /\:/, $l;
        $lang_select .= $_[0] eq $iB::MEMBER->{'LANGUAGE'}
                      ? qq[<option value='$_[0]' selected>$_[1]\n]
                      : qq[<option value='$_[0]'>$_[1]\n];
    }
    $lang_select .= "</select>";
    $obj->{'.html'} .= MenuView::settings_header($iB::MEMBER, $time_select, $time, $lang_select);
    #+-------------------------------------------------------------------------------
    if ($iB::INFO->{'ALLOW_SKINS'} == 1) {
        my @skins = split( /\|\&\|/, $iB::INFO->{'SKINS'} );
        my $skin_select = "<select name='u_skin' class='forminput'>";
        for my $s (@skins) {
            @_ = split /\:/, $s;
            $skin_select .= $_[0] eq $iB::MEMBER->{'MEMBER_SKIN'}
                          ? qq[<option value='$_[0]' selected>$_[1]\n]
                          : qq[<option value='$_[0]'>$_[1]\n];
        }
        $skin_select .= "</select>";
        $obj->{'.html'} .= MenuView::settings_skin($skin_select);
    }
    #+-------------------------------------------------------------------------------
    my $view_ava = qq!<select name='VIEW_AVS' class='forminput'>
                      <option value='1'>$UserCP::lang->{'yes'}</option>
                      <option value='0'>$UserCP::lang->{'no'}</option>
                     !;
    $view_ava =~ s!value='$iB::MEMBER->{'VIEW_AVS'}'>!value='$iB::MEMBER->{'VIEW_AVS'}' selected>!;

    my $view_sig = qq!<select name='VIEW_SIGS' class='forminput'>
                      <option value='1'>$UserCP::lang->{'yes'}</option>
                      <option value='0'>$UserCP::lang->{'no'}</option>
                     !;
    $view_sig =~ s!value='$iB::MEMBER->{'VIEW_SIGS'}'>!value='$iB::MEMBER->{'VIEW_SIGS'}' selected>!;

    my $view_img = qq!<select name='VIEW_IMG' class='forminput'>
                      <option value='1'>$UserCP::lang->{'yes'}</option>
                      <option value='0'>$UserCP::lang->{'no'}</option>
                     !;
    $view_img =~ s!value='$iB::MEMBER->{'VIEW_IMG'}'>!value='$iB::MEMBER->{'VIEW_IMG'}' selected>!;


    $obj->{'.html'} .= MenuView::settings_end( { IMG => $view_img,
                                                 SIG => $view_sig,
                                                 AVA => $view_ava
                                               }
                                             );
    $obj->{'.html'} .= MenuView::CP_end();
}





sub Account ($) {
    my ($obj, $db) = @_;
    $obj->{'.html'} .= MenuView::account($iB::MEMBER);
    $obj->{'.html'} .= MenuView::CP_end();
}


sub Show_menu ($) {
    my $obj = shift;
    my $Nav_tabs = { '00' => 'splash', '01' => 'personal', '02' => 'email', '03' => 'subs', '04' => 'settings', '05' => 'account' };
    my $Nav_color = { };
    for (qw[splash personal email subs settings account]) { $Nav_color->{$_} = $iB::SKIN->{'USERNAV_OFF'} }
    $Nav_color->{ $Nav_tabs->{ $iB::IN{'CODE'} } } = $iB::SKIN->{'USERNAV_ON'};
    $obj->{'.html'} .= MenuView::Menu_bar($Nav_color);
}
   
 

sub Process {
    my ($obj, $db) = @_;
    $obj->SetSession($db);
    my $CodeNo = $std->CheckCodeNo($iB::IN{'CODE'});
    my %Mode = ( '00'     => \&Splash,
                 '01'     => \&Personal,
                 '02'     => \&Email,
                 '03'     => \&Subs,
                 '04'     => \&Settings,
                 '05'     => \&Account,
                 '06'     => \&Cancelsub,
               );
    $Mode{$CodeNo} ? $Mode{$CodeNo}->($obj, $db) : UserCPError($obj, $db);

    $output->print_ikonboard( DB         => $db,
                              STD        => $std,
                              OUTPUT     => $obj->{'.html'},
                              JAVASCRIPT => 1,
                              TITLE      => "iB::Welcome to your Control Panel $iB::MEMBER->{'MEMBER_NAME'}",
                              NAV        => [ 
                                              qq|<a href="$iB::INFO->{'BOARD_URL'}/ikonboard.$iB::INFO->{'CGI_EXT'}?act=UserCP;CODE=00" class='nav'>Your Control Panel Menu</a>|
                                            ]
                            );
} 

#+------------------------------------------------------------------------------------------------------
#+------------------------------------------------------------------------------------------------------

sub LoadForum {
    my ($obj, $db, $forum) = @_;
    $obj->{'.forum_id'} = $forum;
    $obj->{'FORUM'} = $db->select( TABLE   => 'forum_info',
                                   KEY     => $obj->{'.forum_id'},
                                 ) || die $db->{'error'};

}

#+------------------------------------------------------------------------------------------------------

sub LoadTopic {
    my ($obj, $db, $forum, $topic) = @_;

    $obj->{'TOPIC'} = $db->select( TABLE  => 'forum_topics',
                                   ID     => $forum,
                                   KEY    => $topic,
                                 ) || die $db->{'error'};
}

#+------------------------------------------------------------------------------------------------------
sub SetSession {
    my ($obj, $db) = @_;
    require $iB::SKIN->{'DIR'} . '/UserCP/MenuView.pm' or die $!;
    $std->Error(DB=>$db, LEVEL=>'1',MESSAGE=>'no_guest_posting')  unless $iB::MEMBER->{'MEMBER_ID'};
    $obj->Show_menu();
}

#+------------------------------------------------------------------------------------------------------

sub UserCPError  { my ($obj, $db) = @_; $std->Error(DB=>$db,STD=>$std,LEVEL=>'1',MESSAGE=>'incorrect_use') }


#+------------------------------------------------------------------------------------------------------
#+------------------------------------------------------------------------------------------------------

1;

__END__
