package iTextparser;
use strict;

BEGIN {
    require 'Lib/FUNC.pm';
    require 'Boardinfo.pm';
}

$iTextparser::ERROR = undef;

my $INFO  = Boardinfo->new();
my $std   = FUNC::STD->new();
#+------------------------------------------------------------------------------------------------------

sub new {
  my $pkg = shift;
  my $obj = { IMG_CNT => '0', ERROR => undef };
  bless $obj, $pkg;
  return $obj;
}

#+------------------------------------------------------------------------------------------------------

sub Convert_for_db {
    my $obj = shift;
    my $IN  = { TEXT  => "", SMILIES => "", IB_CODE => "", HTML => "", SIG => "", @_, };

    my $Txt = $IN->{'TEXT'};

    return unless $Txt;

    if ($IN->{'IB_CODE'}) {

        goto SMILIES unless ($Txt =~ m#[\[\]\(]#);

        while ($Txt =~ s{\[code\]([\S\s].+?[\S\s])\[/code\]}
                       {my $Tmp = $1;
                        $Tmp =~ s!&lt;!&#60;!g;
                        $Tmp =~ s!&gt;!&#62;!g;
                        $Tmp =~ s!&quot;!&#34;!g;
                        $Tmp =~ s!\s{1};!&#59;!g;
                        $Tmp =~ s!:!&#58;!g;
                        $Tmp =~ s!\[!&#91;!g;
                        $Tmp =~ s!\]!&#93;!g;
                        $Tmp =~ s!\)!&#41;!g;
                        $Tmp =~ s!\(!&#40;!g;
                        $Tmp = qq|<!--c1--><br><b>Code Sample:</b><br><font class='CODE'><!--ec1-->$Tmp<!--c2--></font><!--ec2-->|;
                       }exisog) {}

        my ($Begin, $End);
        if ($Txt =~ m!(\[quote\])(.+?)(\[/quote\])!i) {
            $Txt =~ s{\[quote\]}   {++$Begin;qq[<!--QuoteBegin-->Quote:<br><font class='QUOTE'><\!--QuoteEBegin-->];}eisgx;
            $Txt =~ s{\[/quote\]}  {++$End;  qq[<!--QuoteEnd--></font><!--QuoteEEnd-->];}eisgx;
            if ($Begin != $End) { $obj->{'ERROR'} = 'non_quotes' }
        }

    
        $Txt =~ s!<br>!\n!isg;

        $Txt =~ s!(^|\s)(http:\/\/\S+)!$1."<a href=\"$2\" target=\"_blank\">".$obj->chomp_url($2)."</a>"!eig;
        $Txt =~ s!(^|\s)(https:\/\/\S+)!$1."<a href=\"$2\" target=\"_blank\">".$obj->chomp_url($2)."</a>"!eig;
        $Txt =~ s!(^|\s)(ftp:\/\/\S+)!$1."<a href=\"$2\" target=\"_blank\">".$obj->chomp_url($2)."</a>"!eig;
        $Txt =~ s!(^|\s)([\.\w\-]+\@[\.\w\-]+\.[\.\w\-]+)!$1<a href=\"mailto:$2\">$2</a>!ig;

        if ($INFO->{'ALLOW_IMAGES'}) {

            if ($Txt =~ s#\[img=\s*&quot;\s*(\S+?)\s*&quot;\s*\]#<img src=\"$1\" border=\"0\">#gi
                     or
                $Txt =~ s#\[img=\s*(\S+?)\s*\]#<img src=\"$1\" border=\"0\">#gi
                     or
                $Txt =~ s#\[img\](\S+?)\[/img\]#<img src=\"$1\" border=\"0\">#gi) {

                my $url = $1;
                ++$obj->{'IMG_CNT'};
                if ($INFO->{'MAX_IMAGES'}) {
                    $obj->{'ERROR'} = 'too_many_img' if $obj->{'IMG_CNT'} > $INFO->{'MAX_IMAGES'};
                }

                unless ($INFO->{'ALLOW_DYNAMIC_IMG'}) {
                    $obj->{'ERROR'} = 'no_dynamic' if $url =~ m#[?&;]#;
                }
                my @urls  = split /\//, $url;
                my $image = $urls[$#urls];
                $obj->{'ERROR'} = 'invalid_ext' unless $image =~ m#\A[\d\w\-\_]+\.{1,1}($INFO->{'IMG_EXT'})\Z#g;
            }

            if (($Txt=~ m!(\[FLASH=)(\S+?)(\,)(\S+?)(\])(\S+?)(\[\/FLASH\])!i) and ($INFO->{'ALLOW_FLASH'})) {
                my $width  = $2;
                my $height = $4;
                my $url    = $6;
                $obj->{'ERROR'} = 'flash_too_big' unless $width  and $width  <= $INFO->{'MAX_W_FLASH'};
                $obj->{'ERROR'} = 'flash_too_big' unless $height and $height <= $INFO->{'MAX_H_FLASH'};
                $obj->{'ERROR'} = 'flash_number'  unless $width  =~ /\A[0-9]+\Z/;
                $obj->{'ERROR'} = 'flash_number'  unless $height =~ /\A[0-9]+\Z/;
                $obj->{'ERROR'} = 'flash_url'     unless $url and $url    =~ m#\Ahttp\://(\S+?)\.swf#i;
                $Txt =~ s!(\[FLASH=)(\S+?)(\,)(\S+?)(\])(\S+?)(\[\/FLASH\])!<\!--Flash $2+$4+$6--><OBJECT CLASSID="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" WIDTH=$2 HEIGHT=$4><PARAM NAME=MOVIE VALUE=$6><PARAM NAME=PLAY VALUE=TRUE><PARAM NAME=LOOP VALUE=TRUE><PARAM NAME=QUALITY VALUE=HIGH><EMBED SRC=$6 WIDTH=$2 HEIGHT=$4 PLAY=TRUE LOOP=TRUE QUALITY=HIGH></EMBED></OBJECT><\!--End Flash-->!isg;
            }
        }

        $Txt =~ s!\[email\](\S+?)\[/email\]!<a href="mailto:$1" target='blank'>$1</a>!ig;
        $Txt =~ s!\[url\](\S+?)\[/url\]!"<a href=\"$1\" target='blank'>".$obj->chomp_url($1)."</a>"!eig;
        $Txt =~ s!\[url\s*=\s*\&quot\;\s*(\S+?)\s*\&quot\;\s*\](.*?)\[\/url\]!"<a href=\"$1\" target=\"_blank\">".$obj->chomp_url($2)."</a>"!eisg;
        $Txt =~ s!\[url\s*=\s*(\S+?)\s*\](.*?)\[\/url\]!"<a href=\"$1\" target=\"_blank\">".$obj->chomp_url($2)."</a>"!eisg;
        $Txt =~ s!\[email\s*=\s*\&quot\;([\.\w\-]+\@[\.\w\-]+\.[\.\w\-]+)\s*\&quot\;\s*\](.*?)\[\/email\]!<a href=\"mailto:$1\">$2</a>!isg;
        $Txt =~ s!\[email\s*=\s*([\.\w\-]+\@[\.\w\-]+\.[\w\-]+)\s*\](.*?)\[\/email\]!<a href=\"mailto:$1\">$2</a>!isg;

        $Txt =~ s/\(c\)/&copy;/ig;
        $Txt =~ s/\(r\)/&reg;/ig;
        $Txt =~ s/\(tm\)/&#153;/ig;

        $Txt =~ s!(\[i\])(.+?)(\[/i\])!<i>$2</i>!isg;
        $Txt =~ s!(\[s\])(.+?)(\[/s\])!<s>$2</s>!isg;
        $Txt =~ s!(\[u\])(.+?)(\[/u\])!<u>$2</u>!isg;
        $Txt =~ s!(\[b\])(.+?)(\[/b\])!<b>$2</b>!isg;
        $Txt =~ s!\[size=\s*(.*?)\s*\]\s*(.*?)\s*\[\/size\]!my $size = $1+10; "<span style='font-size:".$size."pt;line-height:100%'>$2</span>"!eisg;
        $Txt =~ s!\[font=\s*(.*?)\s*\]\s*(.*?)\s*\[\/font\]!<span style='font-family:$1'>$2</span>!isg;
        $Txt =~ s!\[color=\s*(.*?)\s*\]\s*(.*?)\s*\[\/color\]!<span style='color:$1'>$2</span>!isg;
        $Txt =~ s!\[list\]!<ul>!isg;
        $Txt =~ s!\[\*\]!<li>!isg;
        $Txt =~ s!\[\/list\]!</ul>!isg;
        $Txt =~ s!\[br\]!<br>!ig;
        
        my $name = $iB::MEMBER->{'MEMBER_NAME'} || $iB::IN{'UserName'} || 'iB User';
        
        $Txt =~ s!(\[me\])(.+?)(\[/me\])!<\!--me&$name--><font class='ME'><center>$name $2</center></font><\!--e-me-->!isg;
        

    }

SMILIES:

    if ($IN->{'SMILIES'}) {
        for my $e (split (/\|&\|/,$INFO->{'EMOTICONS'}) ) {
            my ($type, $image, $p_inc) = split (/\|/,$e);
            next unless $type and $image;
            my $old_emoticon = $type;
            $type = quotemeta ($type);
            $Txt =~ s!(^|\s|\]|\B)$type(\B|\[|\s|$)!$1<\!--emo&$old_emoticon--><img src="$INFO->{'IMAGES_URL'}/emoticons/$image" border="0" valign="absmiddle"><\!--endemo-->$2!isg;
        }
    }

    if ($IN->{'HTML'}) {
        $Txt =~ s!&gt;!>!g;
        $Txt =~ s!&lt;!<!g;
        $Txt =~ s!&amp;!&!g;
        $Txt =~ s!&quot;!"!g;
    }


    if ($INFO->{'WORD_FILTER'}) {
        my @words = split /\|/, $INFO->{'WORD_FILTER'};

        for (@words) {
            my ($original, $method, $replacement) = split /\:/, $_;
            $replacement = "#" x length($original) unless $replacement;
            
            if ($method eq 'e') {
                $Txt =~ s!(\A|\b)$original(\b|\Z|\!|\?|\.)!$replacement!ig;
            } else {
                $Txt =~ s!$original!$replacement!ig;
            }
        }
    }

    $Txt =~ s!\n!<br>!isg;
    $Txt =~ s!([\-\_\;\'\"\,\.\!\@\\%\^\&\*\(\)\d\w\?\+\=\}\{\]\[\`\~]{90})(?=\S)!$1<br>!g;
    return $Txt;    
}


#+------------------------------------------------------------------------------------------------------
#+------------------------------------------------------------------------------------------------------

sub Convert_for_textfield {
    my ($obj, $Txt) = @_;

    $Txt =~ s{<!--Flash (.+?)-->.+?<!--End Flash-->} { my $tmp = $1; my($w,$h,$u) = split (/\+/,$tmp); qq!\[FLASH=$w\,$h\]$u\[/FLASH\]!; }isge;
    $Txt =~ s!(<img src=["'])(\S+)(["'].+?>)!\[img\]$2\[/img\]!isg;
    $Txt =~ s!(<a href=["'])(http|https|ftp|news)://(\S+?)["'].+?>(.+?)</a>!\[URL=$2://$3\]$4\[/URL\]!isg;
    $Txt =~ s!(<a href="mailto:)(.+?)(" class='.+?'>)(.+?)(</a>)!\[EMAIL=$2\]$4\[/EMAIL\]!isg;
    $Txt =~ s!(<i>)(.+?)(</i>)!\[i\]$2\[/i\]!isg;
    $Txt =~ s!(<u>)(.+?)(</u>)!\[u\]$2\[/u\]!isg;
    $Txt =~ s!(<b>)(.+?)(</b>)!\[b\]$2\[/b\]!isg;
    $Txt =~ s!<ul>!\[list\]!isg;
    $Txt =~ s!<li>!\[\*\]!isg;
    $Txt =~ s!</ul>!\[/list\]!isg;
    $Txt =~ s!<span style=['"]font-size\:(.+?)pt;line-height:100%['"]>(.+?)</span>!my $size=$1; $size-=10;"\[size=$size\]$2\[/size\]"!eisg;
    $Txt =~ s!<span style=['"]color\:(.+?)['"]>(.+?)</span>!\[color=$1\]$2\[/color\]!isg;
    $Txt =~ s!<span style=['"]font-family\:(.+?)['"]>(.+?)</span>!\[font=$1\]$2\[/font\]!isg;
    $Txt =~ s!<\!--c1-->(.+?)<\!--ec1-->!\[code\]!isg;
    $Txt =~ s!<\!--c2-->(.+?)<\!--ec2-->!\[/code\]!isg;
    $Txt =~ s!<\!--QuoteBegin-->(.+?)<\!--QuoteEBegin-->!\[quote\]!isg;
    $Txt =~ s!<\!--QuoteEnd-->(.+?)<\!--QuoteEEnd-->!\[/quote\]!isg;
    $Txt =~ s#<!--EDIT\|(.+?)\|(.+?)-->##ig;
    $Txt =~ s!<\!--emo&(.+?)-->.+?<\!--endemo-->!$1!ig;
    if ($Txt =~ m!<\!--me&(.+?)-->(.+?)<\!--e-me-->!ig) {
      my $name = $1;
      my $text = $2;
      $text =~ s!$name!!;
      $Txt =~ s!<\!--me&(.+?)-->(.+?)<\!--e-me-->!$text!ig;
    }
    $Txt =~ s!<br>!\n!ig;
    $Txt =~ s!<!&lt;!g;
    $Txt =~ s!>!&gt;!g;
    $Txt =~ s!"!&quot;!g;
    return $Txt;
}

#+------------------------------------------------------------------------------------------------------
#+------------------------------------------------------------------------------------------------------

sub Convert_for_email ($$) {
    my ($obj, $Txt) = @_;
    $Txt =~ s!<br>!\n!ig;
    $Txt =~ s!(<i>)(.+?)(</i>)!\_$2\_!isg;
    $Txt =~ s!(<b>)(.+?)(</b>)!\*$2\*!isg;
    $Txt =~ s{<!--Flash (.+?)-->.+?<!--End Flash-->} { my $tmp = $1; my($w,$h,$u) = split (/\+/,$tmp); qq!(FLASH MOVIE: (Width: $w) (Height: $h) URL: $u)!; }isge;
    $Txt =~ s!(<a href=["'])(http|https|ftp|news)://(\S+?)["'].+?>(.+?)</a>!(URL: $2://$3)!isg;
    $Txt =~ s!(<a href="mailto:)(.+?)(" class='postcolor'>)(.+?)(</a>)!(EMAIL: $2)!isg;
    $Txt =~ s!<\!--c1-->(.+?)<\!--ec1-->!\n\n---------------------CODE SAMPLE-------------------\n!isg;
    $Txt =~ s!<\!--c2-->(.+?)<\!--ec2-->!\n---------------------CODE SAMPLE-------------------\n\n!isg;
    $Txt =~ s!<\!--QuoteBegin-->(.+?)<\!--QuoteEBegin-->!\n\n---------------------QUOTE-------------------\n!isg;
    $Txt =~ s!<\!--QuoteEnd-->(.+?)<\!--QuoteEEnd-->!\n---------------------QUOTE-------------------\n\n!isg;
    $Txt =~ s!<\!--emo&(.+?)-->.+?<\!--endemo-->!$1!ig;
    $Txt =~ s!(<img src=["'])(\S+)(["']>)!(IMAGE: $2)!isg;
    $Txt =~ s!<(.+?)>!!sg;
    $Txt =~ s!&.+?;!!g;
    return $Txt;
}



sub chomp_url ($$) {
    my ($obj, $the_red_sea) = @_;
    return $the_red_sea unless length($the_red_sea) > 70;
    my ($moses, $did_indeed) = split /\:\/\//, $the_red_sea;
    my @miracle = split "/",$did_indeed;
    return $moses.'://'.$miracle[0].'/'.$miracle[1].'/..../'.$miracle[$#miracle];
}

1;

__END__
