#!/usr/bin/perl
package iB;

#
# Convertor to create indexes.
#


#+------------------------------------------------------------------------------------------------------
#| Ikonboard by Matthew Mecham [ v3.0 ]
#|
#| No parts of this script can be used outside Ikonboard without prior consent.
#| You must keep this header intact and all copyright links visable.
#| (c)2001 Ikonboard.com <http://www.ikonboard.com>
#|
#| Please Read the licence for more information.
#+------------------------------------------------------------------------------------------------------

use strict;

BEGIN {
    use Cwd;
    my $cwd = cwd();
    $iB::PTH = $cwd;
    unshift (@INC, "$iB::PTH");
    unshift (@INC, "$iB::PTH/Data");
    unshift (@INC, "$iB::PTH/Sources");
    unshift (@INC, "$iB::PTH/Skin");
    unshift (@INC, "$iB::PTH/Languages");
    unshift (@INC, "$iB::PTH/Sources/Lib");
    
}
#+------------------------------------------------------------------------------------------------------
use CGI;
use CGI::Carp "fatalsToBrowser";
$iB::Q = new CGI;

use Boardinfo;
$iB::INFO = Boardinfo->new();




    if ($iB::Q->param('act') eq 'run') {

        iB::run();

    } else {

        iB::show();
    }




sub show {
    print $iB::Q->header();
    print $iB::Q->start_html();

    print qq~<b><font size=4>Index Creator</font></b>
             <br><br><font size='3'>This convertor will speed up Ikonboard on new registrations and log in. It creates 2 new indexes,
             MEMBER_EMAIL, contains the email addresses of all the members, MEMBER_NAMES contains all the member names.
             <br><br>
             <a href='create_indexes.cgi?act=run'>Convert members</a>
            ~;
    print $iB::Q->end_html();
}


sub run {

    require "iDatabase/DBM.pm" or die $!;
    my $db = iDatabase->new(DB_DIR => $iB::INFO->{'DB_DIR'} );

    my $count = 0;

    print $iB::Q->header();
    print $iB::Q->start_html();

    print "<b><font size=4>Member Convertor Output</font></b><br>";

    print "Creating MEMBER_EMAIL index";

    $db->create_index( TABLE       => 'member_profiles',
                       INDEX_KEY   => 'MEMBER_EMAIL',
                       FOREIGN_KEY => 'MEMBER_ID',
                     );

    print "Creating MEMBER_NAME index";

    $db->create_index( TABLE       => 'member_profiles',
                       INDEX_KEY   => 'MEMBER_NAME',
                       FOREIGN_KEY => 'MEMBER_ID',
                     );

    my $members = $db->query( TABLE => 'member_profiles' );


    for my $m (@{$members}) {
        $m->{'MEMBER_EMAIL'} = lc($m->{'MEMBER_EMAIL'});
        $db->update_index( TABLE      => 'member_profiles',
                           INDEX_KEY  => 'MEMBER_EMAIL',
                           R_KEY      => $m->{'MEMBER_EMAIL'},
                           R_VALUE    => $m->{'MEMBER_ID'},
                         );

        $db->update_index( TABLE      => 'member_profiles',
                           INDEX_KEY  => 'MEMBER_NAME',
                           R_KEY      => $m->{'MEMBER_NAME'},
                           R_VALUE    => $m->{'MEMBER_ID'},
                         );

        ++$count;
        print "$m->{'MEMBER_NAME'} has been added to the index...<br>";
    }

    print "All done, $count members updated";
    print $iB::Q->end_html();
}
