#!/usr/bin/perl
package iB;

#
#
# IF YOU CAN SEE THIS LINE, YOU DO NOT HAVE PERL INSTALLED AND WILL NOT BE ABLE TO RUN IKONBOARD
#
#+------------------------------------------------------------------------------------------------------
#| Ikonboard by Matthew Mecham [ v3.0 ]
#|
#| No parts of this script can be used outside Ikonboard without prior consent.
#| You must keep this header intact and all copyright links visable.
#| (c)2001 Ikonboard.com <http://www.ikonboard.com>
#|
#| Please Read the licence for more information.
#+------------------------------------------------------------------------------------------------------

use strict;
use File::Path;

BEGIN {
    $iB::PTH = '';
    $iB::EXT = $0;
    $iB::EXT =~s/\\/\//g;
    $iB::EXT =~s/^.*\.(\w+)$/$1/g;

    use Cwd;
    my $cwd = cwd();
    $iB::PTH = $cwd;

    unshift (@INC, "$iB::PTH");
    unshift (@INC, "$iB::PTH/Sources");
    unshift (@INC, "$iB::PTH/Sources/Lib");
    unshift (@INC, "$iB::PTH/INSTALL_DATA");
    unshift (@INC, "$iB::PTH/Data");
    use CGI::Carp "fatalsToBrowser";
}
#+------------------------------------------------------------------------------------------------------
use CGI;
$iB::CGI = new CGI;
%iB::IN  = map { $_ => &iB::make_safe( $iB::CGI->param($_) ) } $iB::CGI->param();



## ENTER YOUR PATH (eg: /home/www/ib3/INSTALL_DATA/Archive/Tar.pm) below!

####              V  V  V  V  V  V  V  V  V  V  V  V

eval { require "$iB::PTH/INSTALL_DATA/Archive/Tar.pm" } || &iB::ERROR("Can't load the Archive::Tar module. $@, please check to see if Archive::Tar is installed on your server.");





eval { iB::Action() }; &iB::ERROR($@) if $@;

#+------------------------------------------------------------------------------------------------------

sub make_safe {
    my $word = shift;
    $word    =~ s|!|&#33;|g;
    return $word;
}

sub Action {

    if ($iB::IN{'STEP'} == 4) {
        &iB::STEP_FOUR();
    } elsif ($iB::IN{'STEP'} == 3) {
        &iB::STEP_THREE();
    } elsif ($iB::IN{'STEP'} == 2) {
        &iB::STEP_TWO();
    } else {
        &iB::INSTALL();
    }

}       


sub INSTALL {

    my $cgi_path = $iB::PTH;
    my $img_path = $iB::PTH;
    $img_path =~ s!\/(cgi-bin|cgi|mod-bin|perl-bin)!!i;

    my $web_url = "http://".$ENV{'HTTP_HOST'};
    my $cgi_url = "http://".$ENV{'HTTP_HOST'}.$ENV{'SCRIPT_NAME'};
    $cgi_url =~s/\/installer\.(cgi|pl)$//g;

    my $img_url = $cgi_url;
    $img_url =~ s!\/(cgi-bin|cgi|mod-bin|perl-bin)!!i;
    $img_url .= "/iB_html";
    $img_path .= "/iB_html";

    my $send_mail;
    for ("/usr/sbin/sendmail", "/usr/lib/sendmail", "/usr/bin/sendmail", "/var/qmail/bin/qmail-inject") {
        $send_mail = $_ if -e $_;
    }

    print $iB::CGI->header();


# HTML

print <<__HTML__;
<html>
    <head>
    <title>Ikonboard Install Wizard</title>
    <style type="text/css">
    .t {font-family: Verdana, Arial, Sans-serif;font-size  : 12px;padding-left: 10px;font-weight: normal;line-height: 150%;color : #333366;}
    .e {font-family: Arial, Sans-serif;font-size  : 12px;font-weight: normal;line-height: 200%;color : #0000EE;}
    .w {font-family: Arial, Sans-serif;font-size  : 12px;font-weight: normal;line-height: 200%;color : #EE0000;}
    .h {font-family: Arial, Sans-serif;padding-top: 5px;padding-left: 10px;font-size  : 20px;font-weight: bold;color : #000000;}
    .i {font-family: Arial, Sans-serif;padding-top: 5px;padding-left: 10px;font-size  : 14px;font-weight: bold;color : #000000;}
	table {border        : 2px solid;width         : 95%;align         : center;vertical-align: top;background-color: #FFFFFF;}
	input {font-family  : Verdana, Arial;width : 95%;padding-top: 5px;border-top   :#000000 solid thin;border-bottom:#000000 solid thin;border-left  :#000000 solid thin;border-right :#000000 solid thin;background-color: #EEEEEE;}
    </style>
    </head>
    <body bgcolor='#EEEEEE' marginheight='0' marginwidth='0' leftmargin='0' topmargin='10'>
    <table cellspacing='1' cellpadding='6' align='center'>
    <form action='installer.cgi' method='post'>
    <input type='hidden' name='STEP' value='2'>
    	<tr>
			<td class='h' valign='top' align='left' colspan='2'><span style='color:#CC0000'>&gt;&gt;</span> Ikonboard Installation Wizard<hr noshade size=1 color='#000000'></td>
		</tr>
		<tr>
			<td class='t' colspan='2' align='left'>Welcome to the iB3 installer. Installation is very straightforward. All we need from you in this step is a little information on where your ikonboard is. Please read the instructions very carefully.</td>
     </tr>
		<tr>
			<td class='i' colspan='2' align='left'><span style='color:#CC0000'>&gt;</span>Ikonboard URLs<br><span class='t'>A URL is what you type into your web browser to access a website.</span> <span class='e'>For Example: http://www.ikonboard.com/</span><br>&nbsp;</td>
        </tr>
		<tr>
			<td class='t' align='left' colspan='2'><b>What is the URL to your Ikonboard CGI directory? (The URL to the directory this installer.cgi file is in)</b>
			<br><br><span style='color:#CC0000'>&gt;</span><input type='text' name='CGI_URL' value='$cgi_url'></td>
	   </tr>
		<tr>
			<td class='t' align='left' colspan='2' bgcolor='#EEEEEE'><b>What is the URL to your Ikonboard "iB_html" directory?</b>
			<br><br><span style='color:#CC0000'>&gt;</span><input type='text' name='IMAGES_URL' value='$img_url'></td>
     </tr>
		<tr>
			<td class='i' colspan='2' align='left'><hr noshade size='1' color='#000000'><span style='color:#CC0000'>&gt;</span>Ikonboard Paths<br><span class='t'>A path is the location of a directory on your server</span> <span class='e'>/home/usr/www/public_html/ikonboard</span><br>&nbsp;</td>
	   </tr>
		<tr>
			<td class='t' align='left' colspan='2'><b>What is the path to your Ikonboard CGI directory? (The path to the directory this installer.cgi file is in)</b>
			<br><br><span style='color:#CC0000'>&gt;</span><input type='text' name='CGI_PATH' value='$cgi_path'></td>
	   </tr>
		<tr>
			<td class='t' align='left' colspan='2' bgcolor='#EEEEEE'><b>What is the path to your Ikonboard "iB_html" directory?</b>
			<br><br><span style='color:#CC0000'>&gt;</span><input type='text' name='IMAGES_PATH' value='$img_path'></td>
	   </tr>
		<tr>
			<td class='i' colspan='2' align='left'><hr noshade size='1' color='#000000'><span style='color:#CC0000'>&gt;</span>Email Information</td>
	   </tr>
		<tr>
			<td class='t' align='left' width='40%'>&nbsp;&nbsp;Email Address for Incoming Emails</td>
			<td class='t' align='left' width='60%'><input type='text' name='EMAIL_IN' value='$ENV{'SERVER_ADMIN'}'></td>
	   </tr>
		<tr>
			<td class='t' align='left' width='40%'>&nbsp;&nbsp;Email Address for outgoing Emails</td>
			<td class='t' align='left' width='60%'><input type='text' name='EMAIL_OUT' value='$ENV{'SERVER_ADMIN'}'></td>
	   </tr>
		<tr>
			<td class='t' align='left' width='40%'>&nbsp;&nbsp;Path to your sendmail program</td>
			<td class='t' align='left' width='60%'><input type='text' name='SEND_MAIL' value='$send_mail'></td>
	   </tr>
		<tr>
			<td class='i' colspan='2' align='left'><span style='color:#CC0000'>&gt;</span>End of Step ONE<br><span class='t'>Click on the button below if you have checked the information above.<br>Please note, that the next step may take up to 5 minutes to process</span></td>
		</tr>
		<tr>
			<td class='i' colspan='2' align='center'><input type='submit' value='Check This Information and Proceed to Step Two' style="font-family:Verdana;width:50%"></td>
		</tr>
      </form>
  </table>
</body>
</html>
__HTML__
}


sub STEP_TWO {

    print $iB::CGI->header();

# HTML

print <<__HTML__;
<html>
    <head>
    <title>Ikonboard Install Wizard</title>
    <style type="text/css">
    .t {font-family: Verdana, Arial, Sans-serif;font-size  : 12px;padding-left: 10px;font-weight: normal;line-height: 150%;color : #333366;}
    .e {font-family: Arial, Sans-serif;font-size  : 12px;font-weight: normal;line-height: 200%;color : #0000EE;}
    .w {font-family: Arial, Sans-serif;font-size  : 12px;font-weight: normal;line-height: 200%;color : #EE0000;}
    .h {font-family: Arial, Sans-serif;padding-top: 5px;padding-left: 10px;font-size  : 20px;font-weight: bold;color : #000000;}
    .i {font-family: Arial, Sans-serif;padding-top: 5px;padding-left: 10px;font-size  : 14px;font-weight: bold;color : #000000;}
	table {border        : 2px solid;width         : 80%;align         : center;vertical-align: top;background-color: #FFFFFF;}
	input {font-family  : "Courier New", Courier, monospace;width        : 95%;border-top   :#000000 solid thin;border-bottom:#000000 solid thin;border-left  :#000000 solid thin;border-right :#000000 solid thin;background-color: #EEEEEE;}
    </style>
    </head>
    <body bgcolor='#EEEEEE' marginheight='0' marginwidth='0' leftmargin='0' topmargin='10'>
    <table cellspacing='0' cellpadding='6' align='center'>
    <form action='installer.cgi' method='post'>
    <input type='hidden' name='STEP' value='3'>
    <input type='hidden' name='CGI_PATH' value='$iB::IN{'CGI_PATH'}'>
    	<tr>
			<td class='h' valign='top' align='left' colspan='2'><span style='color:#CC0000'>&gt;&gt;</span> Ikonboard Installation Wizard<hr noshade size=1 color='#000000'></td>
		</tr>
		<tr>
			<td class='i' colspan='2' align='left'><span style='color:#CC0000'>&gt;</span>Installer Output<br>&nbsp;</td>
     </tr>
__HTML__



    #REMOVE ALL TRAILING SLASHES


    $iB::IN{'CGI_URL'}      =~ s!/+\Z!!;
    $iB::IN{'IMAGES_URL'}   =~ s!/+\Z!!;
    $iB::IN{'CGI_PATH'}     =~ s!/+\Z!!;
    $iB::IN{'IMAGES_PATH'}  =~ s!/+\Z!!;

    my ($sec, $mins, $hours, $day_month, $month, $year, $wday, $yday, $isdst) = localtime(time);

    my $OUT = "Starting installation: $day_month $month: $hours:$mins:$sec\n\n\n";


    $OUT .= "CHECKING URLS...\n\n";

    if ($iB::IN{'CGI_URL'} =~ m#http\://#) {
	    $OUT .= ">>CGI URL is okay (Entered: $iB::IN{'CGI_URL'}) ...\n";
    } else {
	    $OUT .= "+>ERROR: CGI URL *NOT* okay (Entered: $iB::IN{'CGI_URL'}) ...\n";
        &iB::html_error($OUT); exit;
    }

    if ($iB::IN{'IMAGES_URL'} =~ m#http\://#) {
	    $OUT .= ">>Images URL is okay...\n";
    } else {
	    $OUT .= "+>ERROR: Images URL is NOT* okay...\n";
        &iB::html_error($OUT); exit;
    }


    $OUT .= "-------------------------\n";

    $OUT .= "CHECKING PATHS...\n\n";

    if (-e $iB::IN{'CGI_PATH'}) {
	    $OUT .= ">>CGI PATH is okay (Entered: $iB::IN{'CGI_PATH'}) ...\n";
    } else {
	    $OUT .= "+>ERROR: CGI PATH *NOT* okay (Entered: $iB::IN{'CGI_PATH'}) ...\n";
        &iB::html_error($OUT); exit;
    }

    if (-e $iB::IN{'IMAGES_PATH'}) {
	    $OUT .= ">>Images PATH is okay (Entered: $iB::IN{'IMAGES_PATH'})...\n";
    } else {
	    $OUT .= "+>ERROR: Images PATH is NOT* okay (Entered: $iB::IN{'IMAGES_PATH'})...\n";
        &iB::html_error($OUT); exit;
    }

    $OUT .= "-------------------------\n";
    $OUT .= "-------------------------\n";





    ##> Checking Exists/Writable Permissions

    my @dirs = ( "$iB::IN{'CGI_PATH'}/Data", "$iB::IN{'CGI_PATH'}/Database",
                 "$iB::IN{'CGI_PATH'}/Languages", "$iB::IN{'CGI_PATH'}/Skin", "$iB::IN{'CGI_PATH'}/Sources",
                 "$iB::IN{'IMAGES_PATH'}"
               );

    #Lets make sure the dirs are empty.

    for my $r (@dirs) {
        rmtree $r;
    }

    my ($exist, $write);

    for my $d (@dirs) {
        
        unless (-e $d) {
            unless (mkdir ($d, 0777)) {
                $exist .= "$d, ";
            }
        }
        unless (-w $d) {
            unless (chmod (0777, $d)) {
               $write .= "$d, ";
            }
        }
    }


    $exist  =~ s!, \Z!!;
    $write  =~ s!, \Z!!;


    $OUT .= "Checking for Directories\n";

   if ($exist) {
        $OUT .= "+>ERROR: Cannot find: $exist (Are they uploaded?)\n";
        &iB::html_error($OUT); exit;
    }
   if ($write) {
        $OUT .= "+>ERROR: Cannot write to: $write (Are they CHMOD 0777?)\n";
        &iB::html_error($OUT); exit;
    }



    $OUT .= "-------------------------\n";



    $OUT .= "-------------------------\n";
    $OUT .= "UNPACKING TAR FILES\n";



    

    {
        # unpacking Data.tar

        $OUT .= ">>Attempting to unpack Data.tar into $iB::IN{'CGI_PATH'}/Data\n";

        my $cwd = cwd();
        my $tar =  Archive::Tar->new();

        unless ($tar->read($iB::IN{'CGI_PATH'}.'/Data.tar', 0)) {
	        $OUT .= "+>ERROR: Cannot read Data.tar (Is it there and uploaded in Binary?)\n";
            &iB::html_error($OUT); exit;
        }

        chdir $iB::IN{'CGI_PATH'};
        my @files = $tar->list_files();
        $tar->extract(@files, $iB::IN{'CGI_PATH'});
        chdir $cwd;

	    for (@files) {
            $OUT .= "--- Unpacked: ".$_."\n";
        }
    }

    $OUT .= "-------------------------\n";
    


    {
        # unpacking Database.tar

        $OUT .= ">>Attempting to unpack Database.tar into $iB::IN{'CGI_PATH'}/Database\n";

        my $cwd = cwd();
        my $tar = Archive::Tar->new();

        unless ($tar->read($iB::IN{'CGI_PATH'}.'/Database.tar', 0)) {
	        $OUT .= "+>ERROR: Cannot read Database.tar (Is it there and uploaded in Binary?)\n";
            &iB::html_error($OUT); exit;
        }

        chdir $iB::IN{'CGI_PATH'};
        my @files = $tar->list_files();
        $tar->extract(@files, $iB::IN{'CGI_PATH'});
        chdir $cwd;

	    for (@files) {
            $OUT .= "--- Unpacked: ".$_."\n";
        }
    }

    $OUT .= "-------------------------\n";
    

    {
        # unpacking Languages.tar

        $OUT .= ">>Attempting to unpack Languages.tar into $iB::IN{'CGI_PATH'}/Languages\n";

        my $cwd = cwd();
        my $tar = Archive::Tar->new();

        unless ($tar->read($iB::IN{'CGI_PATH'}.'/Languages.tar', 0)) {
	        $OUT .= "+>ERROR: Cannot read Languages.tar (Is it there and uploaded in Binary?)\n";
            &iB::html_error($OUT); exit;
        }

        chdir $iB::IN{'CGI_PATH'};
        my @files = $tar->list_files();
        $tar->extract(@files, $iB::IN{'CGI_PATH'});
        chdir $cwd;

	    for (@files) {
            $OUT .= "--- Unpacked: ".$_."\n";
        }
    }

    $OUT .= "-------------------------\n";

    {
        # unpacking Skin.tar

        $OUT .= ">>Attempting to unpack Skin.tar into $iB::IN{'CGI_PATH'}/Skin\n";

        my $cwd = cwd();
        my $tar = Archive::Tar->new();

        unless ($tar->read($iB::IN{'CGI_PATH'}.'/Skin.tar', 0)) {
	        $OUT .= "+>ERROR: Cannot read Skin.tar (Is it there and uploaded in Binary?)\n";
            &iB::html_error($OUT); exit;
        }

        chdir $iB::IN{'CGI_PATH'};
        my @files = $tar->list_files();
        $tar->extract(@files, $iB::IN{'CGI_PATH'});
        chdir $cwd;

	    for (@files) {
            $OUT .= "--- Unpacked: ".$_."\n";
        }
    }

    $OUT .= "-------------------------\n";

    {
        # unpacking Sources.tar

       $OUT .= ">>Attempting to unpack Sources.tar into $iB::IN{'CGI_PATH'}/Skin\n";

        my $cwd = cwd();
        my $tar = Archive::Tar->new();

        unless ($tar->read($iB::IN{'CGI_PATH'}.'/Sources.tar', 0)) {
	        $OUT .= "+>ERROR: Cannot read Sources.tar (Is it there and uploaded in Binary?)\n";
            &iB::html_error($OUT); exit;
        }

        chdir $iB::IN{'CGI_PATH'};
        my @files = $tar->list_files();
        $tar->extract(@files, $iB::IN{'CGI_PATH'});
        chdir $cwd;

	    for (@files) {
            $OUT .= "--- Unpacked: ".$_."\n";
        }
    }

    $OUT .= "-------------------------\n";

    {
        # unpacking non-cgi.tar

        $OUT .= ">>Attempting to unpack non-cgi.tar into $iB::IN{'IMAGES_PATH'}\n";

        my $cwd = cwd();
        my $tar = Archive::Tar->new();

        unless ($tar->read($iB::IN{'CGI_PATH'}.'/non-cgi.tar', 0)) {
	        $OUT .= "+>ERROR: Cannot read non-cgi.tar (Is it there and uploaded in Binary?)\n";
            &iB::html_error($OUT); exit;
        }

        chdir $iB::IN{'IMAGES_PATH'};
        my @files = $tar->list_files();
        $tar->extract(@files, $iB::IN{'IMAGES_PATH'});
        chdir $cwd;

	    for (@files) {
            $OUT .= "--- Unpacked: ".$_."\n";
        }
    }

    $OUT .= "-------------------------\n";
    $OUT .= "  END OF TAR UNPACKING   \n";
    $OUT .= "-------------------------\n";



    $OUT .= "CHECKING FOR iDATABASE\n";

    eval { require $iB::IN{'CGI_PATH'}.'/Sources/iDatabase/DBM.pm'; };
    unless ($@) {
	    $OUT .= ">>Found iDatabase, module loads...\n";
    } else {
	    $OUT .= "+>ERROR: Could not load iDatabase module..\n";
        &iB::html_error($OUT); exit;
    }



    $OUT .= "CHECKING FOR DATABASE DIRECTORIES\n";

    if (-e $iB::IN{'CGI_PATH'}.'/Database/config/member_profiles.cfg' ) {
	    $OUT .= ">>Found Database structure...\n";
    } else {
	    $OUT .= "+>ERROR: Could not find Database directories..\n";
        &iB::html_error($OUT); exit;
    }


    my $cookie_path = $iB::IN{'CGI_URL'};
    $cookie_path    =~ s!$ENV{'HTTP_HOST'}!!g;
    $cookie_path    =~ s!http\://!!g;


    #ADD TRAILING SLASHES FOR CONFIG FILE

    $iB::IN{'CGI_PATH'}    .= '/' unless $iB::IN{'CGI_PATH'}    =~ m!/+\Z!;
    $iB::IN{'IMAGES_PATH'} .= '/' unless $iB::IN{'IMAGES_PATH'} =~ m!/+\Z!;


    $OUT .= "Writing Boardinfo.pm config file...\n";



    open CONFIG, ">".$iB::IN{'CGI_PATH'}."Data/Boardinfo.pm";
print CONFIG <<__CFG__;
package Boardinfo;
  
  sub new {
    my \$pkg = shift;
    my \$obj = {
        'ADMIN_EMAIL_IN'        => q!$iB::IN{'EMAIL_IN'}!,
        'ADMIN_EMAIL_OUT'       => q!$iB::IN{'EMAIL_OUT'}!,
        'ALLOW_CREATOR_VOTE'    => q!1!,
        'ALLOW_FLASH'           => q!1!,
        'ALLOW_IMAGES'          => q!1!,
        'ALLOW_ONLINE_LIST'     => q!1!,
        'ALLOW_POLLS'           => q!1!,
        'ALLOW_POLL_BUMP'       => q!1!,
        'ALLOW_REGISTER'        => q!1!,
        'ALLOW_SEARCH'          => q!1!,
        'ALLOW_SKINS'           => q!1!,
        'AUTHORISE_GROUP'       => q!1!,
        'AUTHORISE_PRUNE'       => q!30!,
        'AVATARS'               => q!1!,
        'AV_ALLOW_URL'          => q!1!,
        'AV_DIMS'               => q!64x64!,
        'AV_EXT'                => q!gif|jpeg|jpg|swf!,
        'BACKUP_DIR'            => q!$iB::IN{'CGI_PATH'}backups/!,
        'BASE_TIME'             => q!GMT!,
        'BOARDNAME'             => q!Ikonboard v3!,
        'BOARD_DESC'            => q!Website Forums!,
        'BOARD_URL'             => q!$iB::IN{'CGI_URL'}!,
        'B_ONLINE'              => q!1!,
        'CGI_EXT'               => q!cgi!,
        'CHECK_USER_AGENT'      => q!1!,
        'CLOCK_STYLE'           => q!MONTH_NAME YEAR|&|DATE_NUMBER-MONTH_NUMBER-YEAR|&|MONTH_NAME DATE_NUMBER YEAR,HOUR:MIN!,
        'CLOCK_TYPE'            => q!24h!,
        'COOKIE_ID'             => q!iB_!,
        'COOKIE_PATH'           => q!$cookie_path/!,
        'COPYRIGHT_INFO'        => q!2001 Ikonboard.com!,
        'DB_DIR'                => q!$iB::IN{'CGI_PATH'}Database/!,
        'DB_DRIVER'             => q!DBM!,
        'DB_IP'                 => q!!,
        'DB_NAME'               => q!!,
        'DB_PASS'               => q!!,
        'DB_PORT'               => q!!,
        'DB_USER'               => q!!,
        'DISPLAY_MAX_POSTS'     => q!10!,
        'DISPLAY_MAX_TOPICS'    => q!15!,
        'EMAIL_CONTENT'         => q!text!,
        'EMAIL_FOOTER'          => q!!,
        'EMAIL_HEADER'          => q!Email Generated by Ikonboard<br>!,
        'EMAIL_TYPE'            => q!send_mail!,
        'EMOTICONS'             => q!:)|smile.gif|1|&|:(|sad.gif|1|&|:D|biggrin.gif|1|&|:p|tounge.gif|1|&|;)|wink.gif|1|&|???|confused.gif|1|&|:0|shocked.gif|1|&|:angry:|angry.gif|0|&|!,
        'FLOCK'                 => q!1!,
        'FLOOD_CONTROL'         => q!25!,
        'FORCE_LOGIN'           => q!0!,
        'FORUM_SORT_ORDER'      => q!Z-A!,
        'GUEST_GROUP'           => q!2!,
        'HOME_NAME'             => q!Ikonboard.com!,
        'HOME_URL'              => q!http://www.ikonboard.com/test!,
        'HOT_TOPIC'             => q!15!,
        'HTML_DIR'              => q!$iB::IN{'IMAGES_PATH'}non-cgi/!,
        'IKON_DIR'              => q!$iB::IN{'CGI_PATH'}!,
        'IMAGES_URL'            => q!$iB::IN{'IMAGES_URL'}/non-cgi!,
        'IMG_EXT'               => q!gif|jpeg|jpg|swf!,
        'INVITE_FRIEND'         => q!1!,
        'LOG_INVITE'            => q!1!,
        'LANGUAGES'             => q!en:English!,
        'MAX_CHARS'             => q!250!,
        'MAX_H_FLASH'           => q!400!,
        'MAX_IMAGES'            => q!10!,
        'MAX_MESSAGES'          => q!40!,
        'MAX_MSG_SIZE'          => q!40!,
        'MAX_W_FLASH'           => q!200!,
        'MEMBER_GROUP'          => q!3!,
        'MSG_ALLOW_CODE'        => q!1!,
        'MSG_ALLOW_HTML'        => q!0!,
        'MSG_PRUNE_DAYS'        => q!30!,
        'OFFLINE_MESSAGE'       => q!We are currently upgrading to Ikonboard 3, please check back later!,
        'PERL_PATH'             => q!/usr/bin/perl!,
        'PREVIEW_REG'           => q!0!,
        'PRUNE_DAYS'            => q!30!,
        'SAVED_NAMES'           => q!guest!,
        'SEND_MAIL'             => q!$iB::IN{'SEND_MAIL'}!,
        'SESSION_EXPIRATION'    => q!3000!,
        'SHOW_BOARD_RULES'      => q!1!,
        'SHOW_ONLINE'           => q!1!,
        'SHOW_STATS'            => q!1!,
        'SIGNATURE'             => q!The Ikonboard Team!,
        'SKINS'                 => q!Default:Standard Ikonboard Skin!,
        'SKIP_WORDS'            => q!was|but|any|lets|we|let|left|here|i&#39;ll|i|must|say|some|forget|only|are|as|a|is|not|will|be|and|or|this|that|when|then|it|of|the|should|could|course|cant|wont|won&#39;t|can&#39;t|what|see|to|too|hope|will|because|just!,
        'SMTP_SERVER'           => q!localhost!,
        'SORT_KEY'              => q!TOPIC_LAST_DATE!,
        'SUPAD_GROUP'           => q!4!,
        'TEMPLATE_DIR'          => q!$iB::IN{'IMAGES_PATH'}non-cgi/Templates/!,
        'TIME_ZONE'             => q!0!,
        'TOPIC_SORT_ORDER'      => q!A-Z!,
        'USER_NOTIFY'           => q!0!,
        'USE_MAIL_FORM'         => q!1!,
        'VALIDATE_REGISTER'     => q!0!,
        'VERIFY_MAIL'           => q!0!,
        'WORD_FILTER'           => q!hell:e:|damn:e:|asshole:e:!,
        'MAX_POST_LENGTH'       => q!75!,
        'MAX_SIG_LENGTH'        => q!300!,
        'MAX_INTEREST_LENGTH'   => q!300!,
        'MAX_LOCATION_LENGTH'   => q!300!,
    };
    bless \$obj, \$pkg;
    return \$obj;
 }

 1;
__CFG__
    close CONFIG;

    $OUT .= "Boardinfo written to...\n";


    my $db = iDatabase->new( DB_DIR => $iB::IN{'CGI_PATH'}.'Database/');

    # Database: MemberGroups

    $OUT .= "\nADDING DEFAULT MEMBER GROUPS\n";

   local $! = undef;
    open (FILE, "$iB::IN{'CGI_PATH'}INSTALL_DATA/mem_groups.dat");
    unless ($!) {
	    $OUT .= ">>mem_groups.dat file opened...\n";
    } else {
	    $OUT .= "+>ERROR: Could not open 'mem_groups.dat' $!";
        &iB::html_error($OUT); exit;
    }
    my @groups = <FILE>;
    close FILE;

    $db->create_table( TABLE  => 'mem_groups' );

    for my $f (@groups) {
        chomp ($f);
        next unless $f;
        my @entry = split (/\|\^\|/, $f);
        next unless defined $entry[0];
        $db->insert( TABLE   => 'mem_groups',
                     VALUES  => {   VIEW_BOARD          =>  1,
                                    MEM_INFO            =>  $entry[1],
                                    OTHER_TOPICS        =>  $entry[2],
                                    USE_SEARCH          =>  $entry[3],
                                    EMAIL_FRIEND        =>  $entry[4],
                                    INVITE_FRIEND       =>  $entry[5],
                                    EDIT_PROFILE        =>  $entry[6],
                                    POST_NEW_TOPICS     =>  $entry[7],
                                    REPLY_OWN_TOPICS    =>  $entry[8],
                                    REPLY_OTHER_TOPICS  =>  $entry[9],
                                    EDIT_OWN_POSTS      =>  $entry[10],
                                    DELETE_OWN_POSTS    =>  $entry[11],
                                    OPEN_CLOSE_TOPICS   =>  $entry[12],
                                    DELETE_OWN_TOPICS   =>  $entry[13],
                                    POST_POLLS          =>  $entry[14],
                                    VOTE_POLLS          =>  $entry[15],
                                    USE_PM              =>  $entry[16],
                                    IS_SUPMOD           =>  $entry[17],
                                    ACCESS_CP           =>  $entry[18],
                                    TITLE               =>  $entry[19],
                                    CAN_REMOVE          =>  0,
                                    READ_AD_LOGS        =>  $entry[21],
                                    DELETE_AD_LOGS      =>  $entry[22],
                                    EDIT_GROUPS         =>  $entry[23],
                                    APPEND_EDIT         =>  $entry[24],
                                    ACCESS_OFFLINE      =>  $entry[25],
                                    AVOID_Q             =>  $entry[26],
                                    AVOID_FLOOD         =>  $entry[27],           
                              },
                    );
        unless ($db->{'error'}) {
	        $OUT .= ">>Member Group $entry[19] Added...\n";
        } else {
            #Ignore this at this stage
            goto EMAIL if $db->{'error'} =~ m#^Can't open the lock file#i;
	        $OUT .= "+>ERROR: Could not add $entry[19]($db->{'error'})...\n";
            &iB::html_error($OUT); exit;
        }
    }

EMAIL:

    # Database: Email Templates

    $OUT .= "\nADDING DEFAULT EMAIL TEMPLATES\n";

    local $! = undef;
    open (FILE, "$iB::IN{'CGI_PATH'}INSTALL_DATA/email_template.dat");
    unless ($!) {
	    $OUT .= ">>email_template.dat file opened...\n";
    } else {
	    $OUT .= "+>ERROR: Could not open 'email_template.dat' $!";
        &iB::html_error($OUT); exit;
    }

    my @templates = <FILE>;
    close FILE;

    $db->create_table( TABLE  => 'email_templates' );

    for my $t (@templates) {
        chomp ($t);
        next unless $t;
        my @entry = split (/\|\^\|/, $t);
        next unless defined $entry[0];
        $db->insert( TABLE   => 'email_templates',
                     VALUES  => {   ID       =>  $entry[0],
                                    TYPE     =>  $entry[1],
                                    TEMPLATE =>  $entry[2],
                              },
                    );
        unless ($db->{'error'}) {
	        $OUT .= ">>Template $entry[0] Added...\n";
        } else {
            #Ignore this at this stage
            goto RULES if $db->{'error'} =~ m#^Can't open the lock file#i;
	        $OUT .= "+>ERROR: Could not add $entry[0] ($db->{'error'})...\n";
            &iB::html_error($OUT); exit;
        }
    }



    # Database: Board Rules

RULES:

    $OUT .= "\nADDING DEFAULT BOARD RULES\n";

    local $! = undef;
    open (FILE, "$iB::IN{'CGI_PATH'}INSTALL_DATA/board_rules.dat");
    unless ($!) {
	    $OUT .= ">>board_rules.dat file opened...\n";
    } else {
	    $OUT .= "+>ERROR: Could not open 'board_rules.dat' $!";
        &iB::html_error($OUT); exit;
    }

    my @templates = <FILE>;
    close FILE;

    $db->create_table( TABLE  => 'forum_rules' );

    for my $t (@templates) {
        next unless $t;
        chomp ($t);
        my @entry = split (/\|\^\|/, $t);
        next unless defined $entry[0];
        $db->insert( TABLE   => 'forum_rules',
                     VALUES  => {   ID           =>  $entry[0],
                                    RULES_TITLE  =>  $entry[1],
                                    RULES_TEXT   =>  $entry[2],
                                    LAST_UPDATE  =>  time,
                              },
                    );
        unless ($db->{'error'}) {
	        $OUT .= ">>Rules $entry[0] Added...\n";
        } else {
            #Ignore this at this stage
            goto TABLES if $db->{'error'} =~ m#^Can't open the lock file#i;
	        $OUT .= "+>ERROR: Could not add $entry[0] ($db->{'error'})...\n";
            &iB::html_error($OUT); exit;
        }
    }

TABLES:

    $OUT .= "-------------------------\n";
    $OUT .= "Creating Tables...\n";

    for ('board_statistics', 'authorisation', 'active_sessions', 'categories', 'forum_info',
         'forum_moderators', 'forum_polls', 'forum_poll_voters', 'forum_posts', 'forum_subscriptions',
         'forum_topics', 'message_data', 'help', 'message_stats', 'search_log', 'search_results') {

        $db->create_table( TABLE  => $_ );
        $OUT .= "Table: $_ created...\n";

    }
    my ($sec, $mins, $hours, $day_month, $month, $year, $wday, $yday, $isdst) = localtime(time);


    $OUT .= "\n\nInstallation Complete at: $day_month $month: $hours:$mins:$sec\n";

    my $time = time;

    open DAT, ">$iB::IN{'IMAGES_PATH'}"."install-$time.txt";
    print DAT $OUT;
    close DAT;

    $OUT =~ s!>!&gt;!g;

print <<__HTML__;
        <tr>
         <td class='t' colspan'2' align='left'><b>Installtion Status</b><br>
         Installation was a success!<br>
         <br><br>A copy of the installation log has been saved to disk [ <a href='$iB::IN{'IMAGES_URL'}/install-$time.txt' target='_blank'>Installation Log - Opens In New Window</a> ]
         </td>
        </tr>
		<tr>
			<td class='i' colspan='2' align='center'><input type='submit' value='Step Completed, Lets set up an administrators account' style="font-family:Verdana;width:50%"></td>
		<tr>
      </form>
  </table>
</body>
</html>
__HTML__


}

sub STEP_THREE {

    print $iB::CGI->header();

# HTML

print <<__HTML__;
<html>
    <head>
    <title>Ikonboard Install Wizard</title>
    <style type="text/css">
    .t {font-family: Verdana, Arial, Sans-serif;font-size  : 12px;padding-left: 10px;font-weight: normal;line-height: 150%;color : #333366;}
    .e {font-family: Arial, Sans-serif;font-size  : 12px;font-weight: normal;line-height: 200%;color : #0000EE;}
    .w {font-family: Arial, Sans-serif;font-size  : 12px;font-weight: normal;line-height: 200%;color : #EE0000;}
    .h {font-family: Arial, Sans-serif;padding-top: 5px;padding-left: 10px;font-size  : 20px;font-weight: bold;color : #000000;}
    .i {font-family: Arial, Sans-serif;padding-top: 5px;padding-left: 10px;font-size  : 14px;font-weight: bold;color : #000000;}
	table {border        : 2px solid;width         : 95%;align         : center;vertical-align: top;background-color: #FFFFFF;}
	input {font-family  : "Courier New", Courier, monospace;width        : 95%;border-top   :#000000 solid thin;border-bottom:#000000 solid thin;border-left  :#000000 solid thin;border-right :#000000 solid thin;background-color: #EEEEEE;}
    </style>
    </head>
    <body bgcolor='#EEEEEE' marginheight='0' marginwidth='0' leftmargin='0' topmargin='10'>
    <table cellspacing='0' cellpadding='6' align='center'>
    <form action='installer.cgi' method='post'>
    <input type='hidden' name='STEP' value='4'>
    <input type='hidden' name='CGI_PATH' value='$iB::IN{'CGI_PATH'}'>
    	<tr>
			<td class='h' valign='top' align='left' colspan='2'><span style='color:#CC0000'>&gt;&gt;</span> Ikonboard Installation Wizard<hr noshade size=1 color='#000000'></td>
		</tr>
		<tr>
		<td class='t' valign='top' align='left' colspan='2'>
			Welcome to the Ikonboard installation wizard. Please read the instructions carefully to enable you to install your ikonboard as easily as possible. All we need to get you going is a little information about where your ikonboard is. Please double check the information you enter.
			<hr noshade size=1 color='#000000'>
		</td>
		</tr>
		<tr>
			<td class='i' colspan='2' align='left'><span style='color:#CC0000'>&gt;</span>Create a Adminstrator Account<br>&nbsp;</td>
        </tr>
		<tr>
			<td class='t' align='left' width='40%'>&nbsp;&nbsp;Please Choose a Username</td>
			<td class='t' align='left' width='60%'><input type='text' name='MEMBER_NAME'></td>
	   </tr>
		<tr>
			<td class='t' align='left' width='40%'>&nbsp;&nbsp;Please Choose a password</td>
			<td class='t' align='left' width='60%'><input type='text' name='MEMBER_PASS'></td>
	   </tr>
		<tr>
			<td class='t' align='left' width='40%'>&nbsp;&nbsp;RE-TYPE YOUR PASSWORD</td>
			<td class='t' align='left' width='60%'><input type='text' name='MEMBER_PASS_TWO'></td>
	   </tr>
		<tr>
			<td class='t' align='left' width='40%'>&nbsp;&nbsp;Your email address</td>
			<td class='t' align='left' width='60%'><input type='text' name='EMAIL'></td>
	   </tr>
		<tr>
			<td class='t' align='left' width='40%'>&nbsp;&nbsp;RE-TYPE your email address</td>
			<td class='t' align='left' width='60%'><input type='text' name='EMAIL_TWO'></td>
	   </tr>
		<tr>
			<td class='i' colspan='2' align='center'><input type='submit' value='Step Completed, Proceed to step FOUR' style="font-family:Verdana;width:50%"></td>
		<tr>
      </form>
  </table>
</body>
</html>
__HTML__

}

sub STEP_FOUR {
    print $iB::CGI->header();

    $iB::IN{'CGI_PATH'}     =~ s!/+\Z!!;
    $iB::IN{'IMAGES_PATH'}  =~ s!/+\Z!!;

# HTML

print <<__HTML__;
<html>
    <head>
    <title>Ikonboard Install Wizard</title>
    <style type="text/css">
    .t {font-family: Verdana, Arial, Sans-serif;font-size  : 12px;padding-left: 10px;font-weight: normal;line-height: 150%;color : #333366;}
    .e {font-family: Arial, Sans-serif;font-size  : 12px;font-weight: normal;line-height: 200%;color : #0000EE;}
    .w {font-family: Arial, Sans-serif;font-size  : 12px;font-weight: normal;line-height: 200%;color : #EE0000;}
    .h {font-family: Arial, Sans-serif;padding-top: 5px;padding-left: 10px;font-size  : 20px;font-weight: bold;color : #000000;}
    .i {font-family: Arial, Sans-serif;padding-top: 5px;padding-left: 10px;font-size  : 14px;font-weight: bold;color : #000000;}
	table {border        : 2px solid;width         : 95%;align         : center;vertical-align: top;background-color: #FFFFFF;}
	input {font-family  : Verdana, Arial;width        : 95%;border-top   :#000000 solid thin;border-bottom:#000000 solid thin;border-left  :#000000 solid thin;border-right :#000000 solid thin;background-color: #EEEEEE;}
    </style>
    </head>
    <body bgcolor='#EEEEEE' marginheight='0' marginwidth='0' leftmargin='0' topmargin='10'>
    <table cellspacing='0' cellpadding='6' align='center'>
    <form action='installer.cgi' method='post'>
    <input type='hidden' name='STEP' value='4'>
    <input type='hidden' name='CGI_PATH' value='$iB::IN{'CGI_PATH'}'>
    	<tr>
			<td class='h' valign='top' align='left' colspan='2'><span style='color:#CC0000'>&gt;&gt;</span> Ikonboard Installation Wizard<hr noshade size=1 color='#000000'></td>
		</tr>
		<tr>
		<td class='t' valign='top' align='left' colspan='2'>
			Welcome to the Ikonboard installation wizard. Please read the instructions carefully to enable you to install your ikonboard as easily as possible. All we need to get you going is a little information about where your ikonboard is. Please double check the information you enter.
			<hr noshade size=1 color='#000000'>
		</td>
		</tr>
		<tr>
			<td class='i' colspan='2' align='left'><span style='color:#CC0000'>&gt;</span>Final Stage: Adding Administrator to the members database<br>&nbsp;</td>
        </tr>
		<tr>
__HTML__

    #Remove End Slashes

    require "$iB::IN{'CGI_PATH'}/Sources/Lib/Crypt.pm";
    require "$iB::IN{'CGI_PATH'}/Sources/iDatabase/DBM.pm";
    require "$iB::IN{'CGI_PATH'}/Data/Boardinfo.pm";

    my $db = iDatabase->new( DB_DIR => "$iB::IN{'CGI_PATH'}/Database/" );
    my $INFO = Boardinfo->new();

    &iB::ERROR("You must enter a username")          unless $iB::IN{'MEMBER_NAME'};
    &iB::ERROR("You must enter a password")          unless $iB::IN{'MEMBER_PASS'};
    &iB::ERROR("You must retype your password")      unless $iB::IN{'MEMBER_PASS_TWO'};
    &iB::ERROR("You must enter an email address")    unless $iB::IN{'EMAIL'};
    &iB::ERROR("You must retype your email address") unless $iB::IN{'EMAIL_TWO'};

    &iB::ERROR("Email addresses did not match")      unless $iB::IN{'EMAIL_TWO'}   eq $iB::IN{'EMAIL'};
    &iB::ERROR("Passwords did not match")            unless $iB::IN{'MEMBER_PASS'} eq $iB::IN{'MEMBER_PASS_TWO'};

    my $Time = time;
    my $IdPart = substr($iB::IN{'MEMBER_NAME'}, 0, 1);
       $IdPart = ord $IdPart;
    my $member_id = "$IdPart".'-'."$Time";
    my $member_pass = crypt ($iB::IN{'MEMBER_PASS'}, lc (substr($iB::IN{'MEMBER_NAME'}, 0, 2 )));

    $db->create_table( TABLE => 'member_profiles' );

    $db->create_index( TABLE       => 'member_profiles',
                       INDEX_KEY   => 'MEMBER_NAME',
                       FOREIGN_KEY => 'MEMBER_ID'
                     );

    $db->create_index( TABLE       => 'member_profiles',
                       INDEX_KEY   => 'MEMBER_EMAIL',
                       FOREIGN_KEY => 'MEMBER_ID'
                     );

    $iB::IN{'EMAIL'} = lc($iB::IN{'EMAIL'});

    $db->update_index( TABLE      => 'member_profiles',
                       INDEX_KEY  => 'MEMBER_EMAIL',
                       R_KEY      => $iB::IN{'EMAIL'},
                       R_VALUE    => $member_id
                     );

    $db->update_index( TABLE      => 'member_profiles',
                       INDEX_KEY  => 'MEMBER_NAME',
                       R_KEY      => $iB::IN{'MEMBER_NAME'},
                       R_VALUE    => $member_id
                     );

    $db->insert( TABLE  => 'member_profiles',
                 ID     => $member_id,
                 VALUES => { 
                           MEMBER_NAME      => $iB::IN{'MEMBER_NAME'},
                           MEMBER_ID        => $member_id,
                           MEMBER_PASSWORD  => $member_pass,
                           MEMBER_EMAIL     => $iB::IN{'EMAIL'},
                           MEMBER_GROUP     => 4,
                           ALLOW_POST       => 1,
                           MEMBER_POSTS     => 0,
                           MEMBER_LEVEL     => 1,
                           MEMBER_AVATAR    => 'noavatar',
                           MEMBER_IP        => $ENV{'REMOTE_ADDR'},
                           TIME_ADJUST      => 0,
                           LANGUAGE         => 'en',
                           MEMBER_SKIN      => 'Default',
                           MEMBER_JOINED    => time,
                           VIEW_SIGS        => 1,
                           VIEW_IMG         => 1,
                           VIEW_AVS         => 1,
                           }
               );

    unless ($db->{'error'}) {
	    print qq~<td class='e' align='left' colspan='2'>Administrator Added...</td></tr>~;
    } else {
	    print qq~<td class='w' align='left' colspan='2'>Could not add administrator $db->{'error'}...<br>Please use your back button to correct this error</td></tr>~;
       exit;
    }

print <<__HTML__;
		<tr>
			<td class='i' colspan='2' align='left'><span style='color:#CC0000'>&gt;</span>Your Ikonboard is now ready to use!<br>&nbsp;</td>
        </tr>
		<tr>
			<td class='t' align='left' width='40%'>&nbsp;&nbsp;Your account details</td>
			<td class='t' align='left' width='60%'><b>Name</b>:$iB::IN{'MEMBER_NAME'}<br><b>Password:</b>$iB::IN{'MEMBER_PASS'}</td>
	   </tr>
        <tr>
			<td class='i' colspan='2' align='left'><span style='color:#CC0000'>&gt;</span><a href='$INFO->{'BOARD_URL'}/ikonboard.$INFO->{'CGI_EXT'}'>Log into the board, then you can access you CP!</a></td>
        </tr>
  </table>
</body>
</html>
__HTML__


}


sub html_error {
    my $OUT = shift;
    $OUT =~ s!>!&gt;!g;

print <<__HTML__;
        <tr>
         <td class='t' colspan'2' align='left'>AN ERROR OCCURED!<br><b>Installation log</b><br>
         <textarea style='width:95%' rows='30'>$OUT</textarea><br><br>Please use the back button on your browser to go back and correct this error
         </td>
        </tr>
      </table>
</body>
</html>
__HTML__
}











sub ERROR {
    my $message = shift;
       $message =~ s!\n!<br>!g;
    my $other = $! || 'none';
    my $help;
    if ($message =~ m#archive\:\:tar#i) {
        $help = qq~<hr>Check to make sure the Archive Tar module is in the INSTALL_DATA directory.
                   <br>If it is, open up this script (installer.cgi) and look for:<br><br>
                   <font color='blue'>## ENTER YOUR PATH (eg: /home/www/ib3/INSTALL_DATA/Archive/Tar.pm) below!</font>
                   <br><br>And do as it says!, then re-upload back to your server, re-CHMOD and re-run<hr>
                  ~; 
    }
    print $iB::CGI->header();
    print $iB::CGI->start_html("Installer Error");
    print qq~
    <font face='verdana, arial'><h1>An error has occured</h1>
    <hr><font size='2'>
    The error returned was: <b>$message</b> $help
    <br>
    Error messages from perl:<font color='red'> $other</font>
    <br>
    Some information that may help:
    <br><br>
    ~;
    for (keys %ENV) {
        print "$_\t\t\t\t = \t$ENV{$_}<br>";
    }
    print "<br>Please go back to correct this error";
    print $iB::CGI->end_html();
    exit;
}





exit (0);







__END__
